//
//  AddPedidoTableViewController.swift
//  PromoHoreca
//
//  Created by Mireia Izquierdo aymerich on 28/12/18.
//  Copyright © 2018 Mireia Izquierdo aymerich. All rights reserved.
//

import UIKit
import AVKit
import AVFoundation

class AddPedidoTableViewController: UITableViewController, UITextFieldDelegate, UIPickerViewDelegate, UIPickerViewDataSource,UIGestureRecognizerDelegate {

    
    var idEstablecimiento:String = ""
    var idFabricante:String = ""
    var promo:Promociones = Promociones(idPromocion: 0, idFabricante: 0, Nombre: "", Descripcion: "", PrecioUnitario: 0, FechaCaducidad: "", ArchivoAdjunto: "", Imagen: "", Zona:"",TipoProducto:"",TipoEstablecimiento:"",NombreFabricante: "")
    private var activityIndicador: UIActivityIndicatorView = UIActivityIndicatorView()
    var distris : [Distribuidores] = []
    var distriselected : String = ""
    @IBOutlet weak var imgview: UIView!
    @IBOutlet weak var nombre: UILabel!
    @IBOutlet weak var fabricante: UILabel!
    @IBOutlet weak var desc: UITextView!
    @IBOutlet weak var precio: UILabel!
    @IBOutlet weak var distripicker: UIPickerView!
    @IBOutlet weak var stepper: UIStepper!
    @IBOutlet weak var importe: UILabel!
    @IBOutlet weak var cantidad: UITextField!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        cantidad.delegate=self
        self.getDistribuidores()
        distripicker.delegate=self
        distripicker.dataSource=self

        let url = URL(string: promo.Imagen)
        let imageData = NSData(contentsOf: url!)
        if let downloadedImageData = imageData{
            if (promo.Imagen.lowercased().hasSuffix(".jpeg")) || (promo.Imagen.lowercased().hasSuffix(".jpg")) || (promo.Imagen.lowercased().hasSuffix(".png")){
                let image = UIImage(data: downloadedImageData as Data)
                for subview in self.imgview.subviews {
                    subview.removeFromSuperview()
                }
                let vc = UIImageView()
                vc.image = image
                vc.frame = self.imgview.bounds
                vc.autoresizingMask = [.flexibleWidth, .flexibleHeight]
                self.imgview.autoresizesSubviews=true
                self.imgview.addSubview(vc)
                
                
                
            }
            else if (promo.Imagen.lowercased().hasSuffix(".mov")) || (promo.Imagen.lowercased().hasSuffix(".avi")) || (promo.Imagen.lowercased().hasSuffix(".mp4")){
                let player = AVPlayer(url: url!)
                let vc = AVPlayerViewController()
                vc.player = player
                vc.view.frame = self.imgview.bounds
                vc.showsPlaybackControls=true
                self.addChild(vc)
                vc.view.frame = self.imgview.bounds
                vc.view.autoresizingMask = [.flexibleWidth, .flexibleHeight]
                self.imgview.autoresizesSubviews=true
                self.imgview.addSubview(vc.view)
            }
            
            nombre.text = promo.Nombre
            desc.text = promo.Descripcion
            precio.text = String(promo.PrecioUnitario) + " €/Un."
            importe.text = String(promo.PrecioUnitario) + " €"
            cantidad.text = String(Double("1.0")!)
            stepper.value = Double("1.0")!
            fabricante.text = promo.NombreFabricante
            
            
        }

        // Uncomment the following line to preserve selection between presentations
        // self.clearsSelectionOnViewWillAppear = false

        // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
        // self.navigationItem.rightBarButtonItem = self.editButtonItem
        let tapGesture = UITapGestureRecognizer(target: self, action:      #selector(hideKeyboard(_:)))
        tapGesture.cancelsTouchesInView = true
        tableView.addGestureRecognizer(tapGesture)
    }
    
    @objc func hideKeyboard(_ sender: UITapGestureRecognizer) {
        tableView.endEditing(true)
    }
    
    override func viewWillAppear(_ animated: Bool) {
        self.getDistribuidores()
        distripicker.delegate=self
        distripicker.dataSource=self
        self.tableView.reloadData()
    }
    
    override func viewDidAppear(_ animated: Bool) {
        self.getDistribuidores()
        distripicker.delegate=self
        distripicker.dataSource=self
        self.tableView.reloadData()
    }
    
    override func numberOfSections(in tableView: UITableView) -> Int {
        return 1
    }
    
    func numberOfComponents(in pickerView: UIPickerView) -> Int {
        return 1
    }
    
    func pickerView(_ pickerView: UIPickerView, numberOfRowsInComponent component: Int) -> Int {
        return distris.count + 1
    }
    
    func pickerView(_ pickerView: UIPickerView, titleForRow row: Int, forComponent component: Int) -> String? {
        if row == 0{
            return "Distribuidor"
        }else{
            return distris[row-1].Nombre + "-" + distris[row-1].Ciudad
        }
        
        
        
    }
    
    func pickerView(_ pickerView: UIPickerView, didSelectRow row: Int, inComponent component: Int) {
        if row == 0{
            distriselected = "Distribuidor"
        }
        else{
            distriselected = distris[row-1].idDistribuidor
        }
        
    }
    
    func getDistribuidores(){
        UIApplication.shared.beginIgnoringInteractionEvents()
        self.activityIndicador.startAnimating()
        var urlComponents = URLComponents()
        urlComponents.scheme = "http"
        urlComponents.host = "ec2-52-47-86-31.eu-west-3.compute.amazonaws.com"
        urlComponents.path = "/GetDistribuidorEstab"
        let idFabItem = URLQueryItem(name: "idFabricante", value: String(promo.idFabricante))
        urlComponents.queryItems = [idFabItem]
        let idEstabItem = URLQueryItem(name: "idEstablecimiento", value: String(idEstablecimiento))
        urlComponents.queryItems = [idFabItem,idEstabItem]
        guard let url = urlComponents.url else { fatalError("Could not create URL from components") }
        
        var request = URLRequest(url: url)
        request.httpMethod = "GET"
        
        let config = URLSessionConfiguration.default
        let session = URLSession(configuration: config)
        let task = session.dataTask(with: request) { (responseData, response, responseError) in
            DispatchQueue.main.async {
                if let error = responseError {
                    print(error)
                    UIApplication.shared.endIgnoringInteractionEvents()
                    self.activityIndicador.stopAnimating()
                    let alert = UIAlertController(title: "Error", message: "No se han podido obtener los distribuidores.", preferredStyle: UIAlertController.Style.alert)
                    alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                    alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                    self.present(alert, animated: true, completion: nil)
                } else if let jsonData = responseData {
                    // Now we have jsonData, Data representation of the JSON returned to us
                    // from our URLRequest...
                    print(jsonData.description)
                    guard let distribuidores = try? JSONDecoder().decode([String:[Distribuidores]].self, from: jsonData) else {
                        UIApplication.shared.endIgnoringInteractionEvents()
                        self.activityIndicador.stopAnimating()
                        let alert = UIAlertController(title: "Error", message: "No se han podido obtener los distribuidores.", preferredStyle: UIAlertController.Style.alert)
                        alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                        alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                        self.present(alert, animated: true, completion: nil)
                        return
                    }
                    if (distribuidores.count>0){
                        UIApplication.shared.endIgnoringInteractionEvents()
                        self.activityIndicador.stopAnimating()
                        self.distris.removeAll()
                        for distri in distribuidores{
                            for value in distri.value{
                               self.reload(distribuidor: value)
                                
                            }
                            
                        }
                        
                    }
                    
                } else {
                    let error = NSError(domain: "", code: 0, userInfo: [NSLocalizedDescriptionKey : "Data was not retrieved from request"]) as Error
                    print(error)
                    UIApplication.shared.endIgnoringInteractionEvents()
                    self.activityIndicador.stopAnimating()
                    let alert = UIAlertController(title: "Error", message: "No se han podido obtener las promociones.", preferredStyle: UIAlertController.Style.alert)
                    alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                    alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                    self.present(alert, animated: true, completion: nil)
                }
            }
        }
        
        task.resume()
    }
    
    func textFieldShouldReturn(_ textField: UITextField) -> Bool {
        textField.resignFirstResponder()
        return true
    }
    
    @IBAction func valueChanged(_ sender: Any) {
        var cantidads:String = cantidad.text!
        if cantidads == "" {
            cantidads = "1.0"
        }
        if Double(cantidads)! > 100 {
            cantidads = "100.0"
            cantidad.text = "100.0"
        }
        cantidad.text = String(Double(cantidads)!)
        stepper.value = Double(cantidads)!
        importe.text = String(Float(stepper.value) * promo.PrecioUnitario) + " €"
    }
    
    func reload(distribuidor:Distribuidores){
        DispatchQueue.main.async{
            if !(self.distris.contains(where: { $0.idDistribuidor == distribuidor.idDistribuidor })){
                self.distris.append(distribuidor)
            }
            self.tableView.reloadData()
        }
    }
    

    @IBAction func steppedChanged(_ sender: UIStepper) {
        cantidad.text = String(stepper.value)
        importe.text = String(Float(stepper.value) * promo.PrecioUnitario) + " €"
    }
    
    
    @IBAction func hacerPedidoAction(_ sender: Any) {
        let alert = UIAlertController(title: "Realizar pedido", message: "¿Está seguro de que quiere realizar el pedido?", preferredStyle: UIAlertController.Style.alert)
        let okAction = UIAlertAction(title: "OK", style: UIAlertAction.Style.default) {
            UIAlertAction in
            self.doPedido()
        }
        alert.addAction(okAction)
        alert.addAction(UIAlertAction(title: "CANCEL", style: UIAlertAction.Style.default, handler: nil))
        alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
        self.present(alert, animated: true, completion: nil)
        
    }
    
    func doPedido(){
        UIApplication.shared.beginIgnoringInteractionEvents()
        self.activityIndicador.startAnimating()
        if(distriselected == "" || distriselected == "Distribuidor"){
            UIApplication.shared.endIgnoringInteractionEvents()
            self.activityIndicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "Debe escoger un distribuidor para realizar el pedido.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }else{
            var urlComponents = URLComponents()
            urlComponents.scheme = "http"
            urlComponents.host = "ec2-52-47-86-31.eu-west-3.compute.amazonaws.com"
            urlComponents.path = "/CreatePedido"
            let idPromocionItem = URLQueryItem(name: "idPromocion", value: String(promo.idPromocion))
            let idDistribuidorItem = URLQueryItem(name: "idDistribuidor", value: String(distriselected))
            let idEstablecimientoItem = URLQueryItem(name: "idEstablecimiento", value: String(idEstablecimiento))
            let cantidadItem = URLQueryItem(name: "Cantidad", value: cantidad.text)
            let importeItem = URLQueryItem(name: "Importe", value: importe.text?.replacingOccurrences(of: " €", with: ""))
            
            urlComponents.queryItems = [idPromocionItem,idDistribuidorItem,idEstablecimientoItem,cantidadItem,importeItem]
            guard let url = urlComponents.url else { fatalError("Could not create URL from components") }
            
            var request = URLRequest(url: url)
            request.httpMethod = "POST"
            
            let config = URLSessionConfiguration.default
            let session = URLSession(configuration: config)
            let task = session.dataTask(with: request) { (responseData, response, responseError) in
                DispatchQueue.main.async {
                    if let error = responseError {
                        print(error)
                        UIApplication.shared.endIgnoringInteractionEvents()
                        self.activityIndicador.stopAnimating()
                        let alert = UIAlertController(title: "Error", message: "No se ha podido procesar el pedido.", preferredStyle: UIAlertController.Style.alert)
                        alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                        alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                        self.present(alert, animated: true, completion: nil)
                    } else if let jsonData = responseData {
                        // Now we have jsonData, Data representation of the JSON returned to us
                        // from our URLRequest...
                        print(jsonData.description)
                        guard let peticion = try? JSONDecoder().decode(PeticionStatus.self, from: jsonData) else {
                            UIApplication.shared.endIgnoringInteractionEvents()
                            self.activityIndicador.stopAnimating()
                            let alert = UIAlertController(title: "Error", message: "No se ha podido procesar el pedido.", preferredStyle: UIAlertController.Style.alert)
                            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                            self.present(alert, animated: true, completion: nil)
                            return
                        }
                        if (peticion.status == 200){
                            UIApplication.shared.endIgnoringInteractionEvents()
                            self.activityIndicador.stopAnimating()
                            let alert = UIAlertController(title: "Pedido procesado", message: "El pedido se ha procesado correctamente.", preferredStyle: UIAlertController.Style.alert)
                            let okAction = UIAlertAction(title: "OK", style: UIAlertAction.Style.default) {
                                UIAlertAction in
                                self.performSegue(withIdentifier: "backtoPedidoList", sender: nil)
                            }
                            alert.addAction(okAction)
                            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                            self.present(alert, animated: true, completion: nil)
                            return
                        }else{
                            UIApplication.shared.endIgnoringInteractionEvents()
                            self.activityIndicador.stopAnimating()
                            let alert = UIAlertController(title: "Error", message: "No se ha podido procesar el pedido.", preferredStyle: UIAlertController.Style.alert)
                            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                            self.present(alert, animated: true, completion: nil)
                            return
                        }
                        
                    } else {
                        let error = NSError(domain: "", code: 0, userInfo: [NSLocalizedDescriptionKey : "Data was not retrieved from request"]) as Error
                        print(error)
                        UIApplication.shared.endIgnoringInteractionEvents()
                        self.activityIndicador.stopAnimating()
                        let alert = UIAlertController(title: "Error", message: "No se han podido procesar el pedido.", preferredStyle: UIAlertController.Style.alert)
                        alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                        alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                        self.present(alert, animated: true, completion: nil)
                    }
                }
            }
            
            task.resume()
            
        }
    }
}
