//
//  DetalleDistriViewController.swift
//  PromoHoreca
//
//  Created by Mireia Izquierdo aymerich on 28/12/18.
//  Copyright © 2018 Mireia Izquierdo aymerich. All rights reserved.
//

import UIKit
import MapKit


class DetalleDistriViewController: UIViewController {

    @IBOutlet weak var dmapa: MKMapView!
    @IBOutlet weak var dzona: UILabel!
    @IBOutlet weak var dtelefono: UILabel!
    @IBOutlet weak var dciudad: UILabel!
    @IBOutlet weak var dcpostal: UILabel!
    @IBOutlet weak var ddireccion: UILabel!
    @IBOutlet weak var dnombre: UILabel!
    private var activityIndicador:UIActivityIndicatorView = UIActivityIndicatorView()
    var distri:Distribuidores = Distribuidores(idDistribuidor: "", idFabricante: "", Nombre: "", Direccion: "", Ciudad: "", CPostal: "", Telefono: "", Zona: "", Geoposicion: "")
    override func viewDidLoad() {
        super.viewDidLoad()
        self.activityIndicador.center=self.view.center
        self.activityIndicador.autoresizingMask = [.flexibleBottomMargin, .flexibleLeftMargin, .flexibleWidth, .flexibleRightMargin, .flexibleTopMargin, .flexibleHeight, .flexibleBottomMargin]
        self.activityIndicador.hidesWhenStopped = true
        self.activityIndicador.style = .gray
        self.view.addSubview(self.activityIndicador)
        self.title = distri.Nombre
        dzona.text = "Zona: " + distri.Zona
        dtelefono.text = "Teléfono: " + distri.Telefono
        dcpostal.text = "Código Postal: " + distri.CPostal
        dciudad.text = "Ciudad: " + distri.Ciudad
        ddireccion.text="Dirección: " + distri.Direccion
        dnombre.text="Nombre: " + distri.Nombre
        let distribuidor = MKPointAnnotation()
        distribuidor.title = distri.Nombre
        distribuidor.coordinate = CLLocationCoordinate2D(latitude: Double(distri.Geoposicion.replacingOccurrences(of: "{", with: "").replacingOccurrences(of: "}", with: "").split(separator: ",")[0])!, longitude: Double(distri.Geoposicion.replacingOccurrences(of: "{", with: "").replacingOccurrences(of: "}", with: "").split(separator: ",")[1])!)
        dmapa.addAnnotation(distribuidor)
        let center = CLLocationCoordinate2D(latitude: Double(distri.Geoposicion.replacingOccurrences(of: "{", with: "").replacingOccurrences(of: "}", with: "").split(separator: ",")[0])!, longitude: Double(distri.Geoposicion.replacingOccurrences(of: "{", with: "").replacingOccurrences(of: "}", with: "").split(separator: ",")[1])!)
        var region = MKCoordinateRegion(center: center, span: MKCoordinateSpan(latitudeDelta: 0.05, longitudeDelta: 0.05))
        region.center = center
        dmapa.setRegion(region, animated: true)
    }
    
    func borrarDistri(){
        UIApplication.shared.beginIgnoringInteractionEvents()
        self.activityIndicador.startAnimating()
        var urlComponents = URLComponents()
        urlComponents.scheme = "http"
        urlComponents.host = "ec2-52-47-86-31.eu-west-3.compute.amazonaws.com"
        urlComponents.path = "/GetNumPedDistri"
        let idFabItem = URLQueryItem(name: "idDistribuidor", value: distri.idDistribuidor)
        urlComponents.queryItems = [idFabItem]
        guard let url = urlComponents.url else { fatalError("Could not create URL from components") }
        
        var request = URLRequest(url: url)
        request.httpMethod = "GET"
        
        let config = URLSessionConfiguration.default
        let session = URLSession(configuration: config)
        let task = session.dataTask(with: request) { (responseData, response, responseError) in
            DispatchQueue.main.async {
                if let error = responseError {
                    print(error)
                    UIApplication.shared.endIgnoringInteractionEvents()
                    self.activityIndicador.stopAnimating()
                    let alert = UIAlertController(title: "Error", message: "No se han podido obtener los distribuidores.", preferredStyle: UIAlertController.Style.alert)
                    alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                    alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                    self.present(alert, animated: true, completion: nil)
                } else if let jsonData = responseData {
                    // Now we have jsonData, Data representation of the JSON returned to us
                    // from our URLRequest...
                    print(jsonData.description)
                    guard let num = try? JSONDecoder().decode(Count.self, from: jsonData) else {
                        UIApplication.shared.endIgnoringInteractionEvents()
                        self.activityIndicador.stopAnimating()
                        let alert = UIAlertController(title: "Error", message: "No se han podido obtener el numero de pedidos del distribuidor.", preferredStyle: UIAlertController.Style.alert)
                        alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                        alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                        self.present(alert, animated: true, completion: nil)
                        return
                    }
                    if (num.count > 0 ){
                        UIApplication.shared.endIgnoringInteractionEvents()
                        self.activityIndicador.stopAnimating()
                        let alert = UIAlertController(title: "Error", message: "No se ha podido eliminar el distribuidor ya que existen pedidos relacionados con él.", preferredStyle: UIAlertController.Style.alert)
                        alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                        alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                        self.present(alert, animated: true, completion: nil)
                        
                    }else{
                        var urlComponents = URLComponents()
                        urlComponents.scheme = "http"
                        urlComponents.host = "ec2-52-47-86-31.eu-west-3.compute.amazonaws.com"
                        urlComponents.path = "/DeleteDistribuidor"
                        let idDistriItem = URLQueryItem(name: "idDistribuidor", value: self.distri.idDistribuidor)
                        let idFabItem = URLQueryItem(name: "idFabricante", value: self.distri.idFabricante)
                        urlComponents.queryItems = [idDistriItem,idFabItem]
                        guard let url = urlComponents.url else { fatalError("Could not create URL from components") }
                        
                        var request = URLRequest(url: url)
                        request.httpMethod = "POST"
                        
                        let config = URLSessionConfiguration.default
                        let session = URLSession(configuration: config)
                        let task = session.dataTask(with: request) { (responseData, response, responseError) in
                            DispatchQueue.main.async {
                                if let error = responseError {
                                    print(error)
                                    UIApplication.shared.endIgnoringInteractionEvents()
                                    self.activityIndicador.stopAnimating()
                                    let alert = UIAlertController(title: "Error", message: "No se han podido obtener los distribuidores.", preferredStyle: UIAlertController.Style.alert)
                                    alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                                    alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                                    self.present(alert, animated: true, completion: nil)
                                } else if let jsonData = responseData {
                                    // Now we have jsonData, Data representation of the JSON returned to us
                                    // from our URLRequest...
                                    print(jsonData.description)
                                    guard let peticion = try? JSONDecoder().decode(PeticionStatus.self, from: jsonData) else {
                                        UIApplication.shared.endIgnoringInteractionEvents()
                                        self.activityIndicador.stopAnimating()
                                        let alert = UIAlertController(title: "Error", message: "No se han podido eliminar el distribuidor.", preferredStyle: UIAlertController.Style.alert)
                                        alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                                        alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                                        self.present(alert, animated: true, completion: nil)
                                        return
                                    }
                                    if ( peticion.status==200){
                                        UIApplication.shared.endIgnoringInteractionEvents()
                                        self.activityIndicador.stopAnimating()
                                        let alert = UIAlertController(title: "Distribuidor eliminado", message: "El distribuidor se ha eliminado", preferredStyle: UIAlertController.Style.alert)
                                        let okAction = UIAlertAction(title: "OK", style: UIAlertAction.Style.default) {
                                            UIAlertAction in
                                            self.performSegue(withIdentifier: "backtodistris", sender: nil)
                                        }
                                        alert.addAction(okAction)
                                        alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                                        self.present(alert, animated: true, completion: nil)
                                        return
                                    }else{
                                        UIApplication.shared.endIgnoringInteractionEvents()
                                        self.activityIndicador.stopAnimating()
                                        let alert = UIAlertController(title: "Error", message: "No se han podido eliminar el distribuidor.", preferredStyle: UIAlertController.Style.alert)
                                        alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                                        alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                                        self.present(alert, animated: true, completion: nil)
                                        return
                                    }
                                }
                            }
                            
                        }
                        task.resume()
                    }
                        
                } else {
                    let error = NSError(domain: "", code: 0, userInfo: [NSLocalizedDescriptionKey : "Data was not retrieved from request"]) as Error
                    print(error)
                    UIApplication.shared.endIgnoringInteractionEvents()
                    self.activityIndicador.stopAnimating()
                    let alert = UIAlertController(title: "Error", message: "No se han podido obtener el numero de pedidos del distribuidor.", preferredStyle: UIAlertController.Style.alert)
                    alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                    alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                    self.present(alert, animated: true, completion: nil)
                }
            }
        }
        
        task.resume()
        
    }

        
    @IBAction func BorrarAction(_ sender: Any) {
        let alert = UIAlertController(title: "Borrar distribuidor", message: "¿Está seguro de que quiere borrar el distribuidor?", preferredStyle: UIAlertController.Style.alert)
        let okAction = UIAlertAction(title: "OK", style: UIAlertAction.Style.default) {
            UIAlertAction in
            self.borrarDistri()
        }
        alert.addAction(okAction)
        alert.addAction(UIAlertAction(title: "CANCEL", style: UIAlertAction.Style.default, handler: nil))
        alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
        self.present(alert, animated: true, completion: nil)
    }
    
    



}
