//
//  DetalleEstabTableViewController.swift
//
//
//  Created by Mireia Izquierdo aymerich on 9/12/18.
//

import UIKit
import AVKit
import AVFoundation

class DetalleEstabTableViewController: UITableViewController, UITextFieldDelegate {
    
    @IBOutlet weak var pedButton: UIButton!
    @IBOutlet weak var likeB: UIButton!
    @IBOutlet weak var tcomment: UITextField!
    @IBOutlet weak var comentarios: UITextView!
    @IBOutlet weak var tipoprod: UILabel!
    @IBOutlet weak var desc: UITextView!
    @IBOutlet weak var fabricante: UILabel!
    @IBOutlet weak var fecha: UILabel!
    @IBOutlet weak var precio: UILabel!
    
    @IBOutlet weak var favB: UIBarButtonItem!
    @IBOutlet weak var mediaView: UIView!
    @IBOutlet weak var numCom: UILabel!
    @IBOutlet weak var numLikes: UILabel!
    var promo:Promociones = Promociones(idPromocion: 0, idFabricante: 0, Nombre: "", Descripcion: "", PrecioUnitario: 0, FechaCaducidad: "", ArchivoAdjunto: "", Imagen: "", Zona:"",TipoProducto:"",TipoEstablecimiento:"",NombreFabricante: "")
    var numlikes = ""
    var numcomments = ""
    var establecimientoId = ""
    var fav : Bool = false
    var like : Bool = false
    var enableped : Bool = false
    override func viewDidLoad() {
        super.viewDidLoad()
        self.title=promo.Nombre
        self.esfab()
        self.esLike()
        self.existDistri()
        self.tcomment.delegate=self
        let url = URL(string: promo.Imagen)
        let imageData = NSData(contentsOf: url!)
        if let downloadedImageData = imageData{
            if (promo.Imagen.lowercased().hasSuffix(".jpeg")) || (promo.Imagen.lowercased().hasSuffix(".jpg")) || (promo.Imagen.lowercased().hasSuffix(".png")){
                let image = UIImage(data: downloadedImageData as Data)
                for subview in self.mediaView.subviews {
                    subview.removeFromSuperview()
                }
                let vc = UIImageView()
                vc.image = image
                vc.frame = self.mediaView.bounds
                vc.autoresizingMask = [.flexibleWidth, .flexibleHeight]
                self.mediaView.autoresizesSubviews=true
                self.mediaView.addSubview(vc)
                
                
                
            }
            else if (promo.Imagen.lowercased().hasSuffix(".mov")) || (promo.Imagen.lowercased().hasSuffix(".avi")) || (promo.Imagen.lowercased().hasSuffix(".mp4")){
                let player = AVPlayer(url: url!)
                let vc = AVPlayerViewController()
                vc.player = player
                vc.view.frame = self.mediaView.bounds
                vc.showsPlaybackControls=true
                self.addChild(vc)
                vc.view.frame = self.mediaView.bounds
                vc.view.autoresizingMask = [.flexibleWidth, .flexibleHeight]
                self.mediaView.autoresizesSubviews=true
                self.mediaView.addSubview(vc.view)
            }
            
        }
        numCom.text = numcomments
        numLikes.text = numlikes
        precio.text = String(promo.PrecioUnitario) + " €/Unidad"
        tipoprod.text = promo.TipoProducto
        
        fecha.text = promo.FechaCaducidad
        desc.text = promo.Descripcion
        fabricante.text = promo.NombreFabricante
        
        if enableped == true {
            pedButton.isEnabled=true
            pedButton.isUserInteractionEnabled=true
            pedButton.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
        }else{
            pedButton.isEnabled=false
            pedButton.isUserInteractionEnabled=false
            pedButton.tintColor = UIColor.gray
        }
        
        var line = "";
        var urlComponents = URLComponents()
        urlComponents.scheme = "http"
        urlComponents.host = "ec2-52-47-86-31.eu-west-3.compute.amazonaws.com"
        urlComponents.path = "/GetPromoComentarios"
        let idFabItem = URLQueryItem(name: "idPromocion", value: String(promo.idPromocion))
        urlComponents.queryItems = [idFabItem]
        guard let urle = urlComponents.url else { fatalError("Could not create URL from components") }
        
        var request = URLRequest(url: urle)
        request.httpMethod = "GET"
        
        let config = URLSessionConfiguration.default
        let session = URLSession(configuration: config)
        let task = session.dataTask(with: request) { (responseData, response, responseError) in
            DispatchQueue.main.async {
                if let jsonData = responseData {
                    // Now we have jsonData, Data representation of the JSON returned to us
                    // from our URLRequest...
                    print(jsonData.description)
                    let comentarios = try? JSONDecoder().decode([String:[Comments]].self, from: jsonData)
                    if (comentarios!.count>0){
                        for com in comentarios!{
                            for comment in com.value{
                                line += comment.nombre + ": " + comment.comentario + "\n"
                            }
                            
                        }
                        
                        //let attributedString = NSMutableAttributedString(string: line as String, attributes: [NSAttributedString.Key.font:UIFont.systemFont(ofSize: 15.0)])
                        
                        //let boldFontAttribute = [NSAttributedString.Key.font: UIFont.boldSystemFont(ofSize: 15.0)]
                        
                        let attrStr = NSMutableAttributedString(string: line)
                        let inputLength = attrStr.string.count
                        var range = NSRange(location: 0, length: attrStr.length)
                        
                        for com in comentarios!{
                            for comment in com.value{
                                let searchString = comment.nombre + ": "
                                let searchLength = searchString.count
                                
                                while (range.location != NSNotFound) {
                                    range = (attrStr.string as NSString).range(of: searchString, options: [], range: range)
                                    if (range.location != NSNotFound) {
                                        attrStr.addAttribute(NSAttributedString.Key.font, value:UIFont.boldSystemFont(ofSize: 15), range: NSRange(location: range.location, length: searchLength))
                                        range = NSRange(location: range.location + range.length, length: inputLength - (range.location + range.length))
                                    }
                                }
                                
                            }
                            
                        }
                        
                        self.comentarios.attributedText = attrStr
                        
                        
                        
                        
                        /*for com in comentarios!{
                         for comment in com.value{
                         attributedString.addAttributes(boldFontAttribute, range: NSString(string: line).range(of: comment.nombre + ": "))
                         }
                         
                         }
                         self.tcomment.attributedText = attributedString*/
                        
                    }
                    
                    
                }
            }
        }
        
        task.resume()
        
        // Uncomment the following line to preserve selection between presentations
        // self.clearsSelectionOnViewWillAppear = false
        
        // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
        // self.navigationItem.rightBarButtonItem = self.editButtonItem
    }
    
    override func viewDidAppear(_ animated: Bool) {
        self.existDistri()
        if enableped == true {
            pedButton.isEnabled=true
            pedButton.isUserInteractionEnabled=true
            pedButton.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
        }else{
            pedButton.isEnabled=false
            pedButton.isUserInteractionEnabled=false
            pedButton.tintColor = UIColor.gray
        }
        if(fav) {
            self.favB.image = UIImage(named: "starfull")
        }else{
            self.favB.image = UIImage(named: "star")
        }
        if(like) {
            self.likeB.setImage(UIImage(named: "heartfull"), for: UIControl.State.normal)
        }else{
            self.likeB.setImage(UIImage(named: "heart"), for: UIControl.State.normal)
        }
    }
    
    // MARK: - Table view data source
    
    override func numberOfSections(in tableView: UITableView) -> Int {
        // #warning Incomplete implementation, return the number of sections
        return 1
    }
    
    
    func esfab(){
        var urlComponents = URLComponents()
        urlComponents.scheme = "http"
        urlComponents.host = "ec2-52-47-86-31.eu-west-3.compute.amazonaws.com"
        urlComponents.path = "/GetFav"
        let idPromocion = URLQueryItem(name: "idPromocion", value: String(promo.idPromocion))
        let idEstablecimiento = URLQueryItem(name: "idEstablecimiento", value: establecimientoId)
        urlComponents.queryItems = [idPromocion,idEstablecimiento]
        guard let urle = urlComponents.url else { fatalError("Could not create URL from components") }
        
        var request = URLRequest(url: urle)
        request.httpMethod = "GET"
        
        let config = URLSessionConfiguration.default
        let session = URLSession(configuration: config)
        let task = session.dataTask(with: request) { (responseData, response, responseError) in
            DispatchQueue.main.async {
                if let jsonData = responseData {
                    // Now we have jsonData, Data representation of the JSON returned to us
                    // from our URLRequest...
                    print(jsonData.description)
                    let status = try? JSONDecoder().decode(PeticionStatus.self, from: jsonData)
                    if (status?.status == 200){
                        self.fav = true
                    }
                    else{
                        self.fav = false
                    }
                    
                    
                    
                    
                    
                }
            }
        }
        
        task.resume()
    }
    
    func existDistri(){
        var urlComponents = URLComponents()
        urlComponents.scheme = "http"
        urlComponents.host = "ec2-52-47-86-31.eu-west-3.compute.amazonaws.com"
        urlComponents.path = "/GetNumDistriZona"
        let idFabricante = URLQueryItem(name: "idFabricante", value: String(promo.idFabricante))
        let idEstablecimiento = URLQueryItem(name: "idEstablecimiento", value: establecimientoId)
        urlComponents.queryItems = [idFabricante,idEstablecimiento]
        guard let urle = urlComponents.url else { fatalError("Could not create URL from components") }
        
        var request = URLRequest(url: urle)
        request.httpMethod = "GET"
        
        let config = URLSessionConfiguration.default
        let session = URLSession(configuration: config)
        let task = session.dataTask(with: request) { (responseData, response, responseError) in
            DispatchQueue.main.async {
                if let jsonData = responseData {
                    // Now we have jsonData, Data representation of the JSON returned to us
                    // from our URLRequest...
                    print(jsonData.description)
                    let count = try? JSONDecoder().decode(Count.self, from: jsonData)
                    if (count!.count > 0){
                        self.enableped = true
                    }
                    else{
                        self.enableped = false
                    }
                    
                    
                    
                    
                    
                }
            }
        }
        
        task.resume()
    }
    
    
    @IBAction func darFav(_ sender: Any) {
        
        if(fav) {
            var urlComponents = URLComponents()
            urlComponents.scheme = "http"
            urlComponents.host = "ec2-52-47-86-31.eu-west-3.compute.amazonaws.com"
            urlComponents.path = "/DeleteFav"
            let idPromocion = URLQueryItem(name: "idPromocion", value: String(promo.idPromocion))
            let idEstablecimiento = URLQueryItem(name: "idEstablecimiento", value: establecimientoId)
            urlComponents.queryItems = [idPromocion,idEstablecimiento]
            guard let urle = urlComponents.url else { fatalError("Could not create URL from components") }
            
            var request = URLRequest(url: urle)
            request.httpMethod = "POST"
            
            let config = URLSessionConfiguration.default
            let session = URLSession(configuration: config)
            let task = session.dataTask(with: request) { (responseData, response, responseError) in
                DispatchQueue.main.async {
                    if let jsonData = responseData {
                        // Now we have jsonData, Data representation of the JSON returned to us
                        // from our URLRequest...
                        print(jsonData.description)
                        let status = try? JSONDecoder().decode(PeticionStatus.self, from: jsonData)
                        if (status?.status == 200){
                            let alert = UIAlertController(title: "OK", message: "La promoción se ha borrado de favoritos.", preferredStyle: UIAlertController.Style.alert)
                            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                            self.present(alert, animated: true, completion: nil)
                            self.favB.image = UIImage(named: "star")
                            self.fav=false
                        }
                        else{
                            let alert = UIAlertController(title: "Error", message: "No se ha podido borrar la promoción de favoritos.", preferredStyle: UIAlertController.Style.alert)
                            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                            self.present(alert, animated: true, completion: nil)
                        }
                        
                    }
                }
            }
            
            task.resume()
            
        }else{
            var urlComponents = URLComponents()
            urlComponents.scheme = "http"
            urlComponents.host = "ec2-52-47-86-31.eu-west-3.compute.amazonaws.com"
            urlComponents.path = "/CreateFav"
            let idPromocion = URLQueryItem(name: "idPromocion", value: String(promo.idPromocion))
            let idEstablecimiento = URLQueryItem(name: "idEstablecimiento", value: establecimientoId)
            urlComponents.queryItems = [idPromocion,idEstablecimiento]
            guard let urle = urlComponents.url else { fatalError("Could not create URL from components") }
            
            var request = URLRequest(url: urle)
            request.httpMethod = "POST"
            
            let config = URLSessionConfiguration.default
            let session = URLSession(configuration: config)
            let task = session.dataTask(with: request) { (responseData, response, responseError) in
                DispatchQueue.main.async {
                    if let jsonData = responseData {
                        // Now we have jsonData, Data representation of the JSON returned to us
                        // from our URLRequest...
                        print(jsonData.description)
                        let status = try? JSONDecoder().decode(PeticionStatus.self, from: jsonData)
                        if (status?.status == 200){
                            let alert = UIAlertController(title: "OK", message: "La promoción se ha guardado en favoritos.", preferredStyle: UIAlertController.Style.alert)
                            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                            self.present(alert, animated: true, completion: nil)
                            self.favB.image = UIImage(named: "starfull")
                            self.fav=true
                        }
                        else{
                            let alert = UIAlertController(title: "Error", message: "No se ha podido guardar la promoción en favoritos.", preferredStyle: UIAlertController.Style.alert)
                            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                            self.present(alert, animated: true, completion: nil)
                        }
                        
                    }
                }
            }
            
            task.resume()
            
        }
    }
    
    func esLike(){
        var urlComponents = URLComponents()
        urlComponents.scheme = "http"
        urlComponents.host = "ec2-52-47-86-31.eu-west-3.compute.amazonaws.com"
        urlComponents.path = "/GetLike"
        let idPromocion = URLQueryItem(name: "idPromocion", value: String(promo.idPromocion))
        let idEstablecimiento = URLQueryItem(name: "idEstablecimiento", value: establecimientoId)
        urlComponents.queryItems = [idPromocion,idEstablecimiento]
        guard let urle = urlComponents.url else { fatalError("Could not create URL from components") }
        
        var request = URLRequest(url: urle)
        request.httpMethod = "GET"
        
        let config = URLSessionConfiguration.default
        let session = URLSession(configuration: config)
        let task = session.dataTask(with: request) { (responseData, response, responseError) in
            DispatchQueue.main.async {
                if let jsonData = responseData {
                    // Now we have jsonData, Data representation of the JSON returned to us
                    // from our URLRequest...
                    print(jsonData.description)
                    let status = try? JSONDecoder().decode(PeticionStatus.self, from: jsonData)
                    if (status?.status == 200){
                        self.like = true
                    }
                    else{
                        self.like = false
                    }
                    
                    
                    
                    
                    
                }
            }
        }
        
        task.resume()
    }
    
    @IBAction func darLike(_ sender: Any) {
        if(like) {
            var urlComponents = URLComponents()
            urlComponents.scheme = "http"
            urlComponents.host = "ec2-52-47-86-31.eu-west-3.compute.amazonaws.com"
            urlComponents.path = "/DeleteLike"
            let idPromocion = URLQueryItem(name: "idPromocion", value: String(promo.idPromocion))
            let idEstablecimiento = URLQueryItem(name: "idEstablecimiento", value: establecimientoId)
            urlComponents.queryItems = [idPromocion,idEstablecimiento]
            guard let urle = urlComponents.url else { fatalError("Could not create URL from components") }
            
            var request = URLRequest(url: urle)
            request.httpMethod = "POST"
            
            let config = URLSessionConfiguration.default
            let session = URLSession(configuration: config)
            let task = session.dataTask(with: request) { (responseData, response, responseError) in
                DispatchQueue.main.async {
                    if let jsonData = responseData {
                        // Now we have jsonData, Data representation of the JSON returned to us
                        // from our URLRequest...
                        print(jsonData.description)
                        let status = try? JSONDecoder().decode(PeticionStatus.self, from: jsonData)
                        if (status?.status == 200){
                            self.likeB.setImage(UIImage(named: "heart"), for: UIControl.State.normal)
                            self.getPromoNumLikes(numPromo: self.promo.idPromocion)
                            self.like=false
                        }
                        else{
                            let alert = UIAlertController(title: "Error", message: "No se ha podido borrar el like a la promoción de favoritos.", preferredStyle: UIAlertController.Style.alert)
                            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                            self.present(alert, animated: true, completion: nil)
                        }
                        
                    }
                }
            }
            
            task.resume()
            
        }else{
            var urlComponents = URLComponents()
            urlComponents.scheme = "http"
            urlComponents.host = "ec2-52-47-86-31.eu-west-3.compute.amazonaws.com"
            urlComponents.path = "/CreateLike"
            let idPromocion = URLQueryItem(name: "idPromocion", value: String(self.promo.idPromocion))
            let idEstablecimiento = URLQueryItem(name: "idEstablecimiento", value: self.establecimientoId)
            urlComponents.queryItems = [idPromocion,idEstablecimiento]
            guard let urle = urlComponents.url else { fatalError("Could not create URL from components") }
            
            var request = URLRequest(url: urle)
            request.httpMethod = "POST"
            
            let config = URLSessionConfiguration.default
            let session = URLSession(configuration: config)
            let task = session.dataTask(with: request) { (responseData, response, responseError) in
                DispatchQueue.main.async {
                    if let jsonData = responseData {
                        // Now we have jsonData, Data representation of the JSON returned to us
                        // from our URLRequest...
                        print(jsonData.description)
                        let status = try? JSONDecoder().decode(PeticionStatus.self, from: jsonData)
                        if (status?.status == 200){
                            self.likeB.setImage(UIImage(named: "heartfull"), for: UIControl.State.normal)
                            self.getPromoNumLikes(numPromo: self.promo.idPromocion)
                            self.like = true
                        }
                        else{
                            let alert = UIAlertController(title: "Error", message: "No se ha podido dar like a la promoción en favoritos.", preferredStyle: UIAlertController.Style.alert)
                            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                            self.present(alert, animated: true, completion: nil)
                        }
                        
                    }
                }
            }
            
            task.resume()
            
        }
    }
    
    
    func getPromoNumComments(numPromo:Int){
        var urlComponents = URLComponents()
        urlComponents.scheme = "http"
        urlComponents.host = "ec2-52-47-86-31.eu-west-3.compute.amazonaws.com"
        urlComponents.path = "/GetPromoNumComment"
        let idFabItem = URLQueryItem(name: "idPromocion", value: String(numPromo))
        urlComponents.queryItems = [idFabItem]
        guard let url = urlComponents.url else { fatalError("Could not create URL from components") }
        
        var request = URLRequest(url: url)
        request.httpMethod = "GET"
        
        let config = URLSessionConfiguration.default
        let session = URLSession(configuration: config)
        let task = session.dataTask(with: request) { (responseData, response, responseError) in
            DispatchQueue.main.async {
                if let jsonData = responseData {
                    // Now we have jsonData, Data representation of the JSON returned to us
                    // from our URLRequest...
                    print(jsonData.description)
                    let comments = try? JSONDecoder().decode(Count.self, from: jsonData)
                    if (comments?.count != nil){
                        self.numcomments = String((comments?.count)!)
                        self.refresh()
                    }else{
                        self.numcomments = String(0)
                    }
                    
                    
                    
                }
            }
        }
        
        task.resume()
        
    }
    
    func getPromoNumLikes(numPromo:Int){
        var urlComponents = URLComponents()
        urlComponents.scheme = "http"
        urlComponents.host = "ec2-52-47-86-31.eu-west-3.compute.amazonaws.com"
        urlComponents.path = "/GetPromoNumLikes"
        let idFabItem = URLQueryItem(name: "idPromocion", value: String(numPromo))
        urlComponents.queryItems = [idFabItem]
        guard let url = urlComponents.url else { fatalError("Could not create URL from components") }
        
        var request = URLRequest(url: url)
        request.httpMethod = "GET"
        
        let config = URLSessionConfiguration.default
        let session = URLSession(configuration: config)
        let task = session.dataTask(with: request) { (responseData, response, responseError) in
            DispatchQueue.main.async {
                if let jsonData = responseData {
                    // Now we have jsonData, Data representation of the JSON returned to us
                    // from our URLRequest...
                    print(jsonData.description)
                    let comments = try? JSONDecoder().decode(Count.self, from: jsonData)
                    if (comments?.count != nil){
                        self.numlikes=String((comments?.count)!)
                        self.refresh()
                    }else{
                        self.numlikes=String(0)
                    }
                    
                    
                    
                }
            }
        }
        task.resume()
    }
    
    func refresh(){
        DispatchQueue.main.async {
            if self.enableped == true {
                self.pedButton.isEnabled=true
                self.pedButton.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            }else{
                self.pedButton.isEnabled=false
                self.pedButton.tintColor = UIColor.gray
            }
            self.numLikes.text = self.numlikes
            self.numCom.text = self.numcomments
        }
    }
    
    @IBAction func enviarComment(_ sender: Any) {
        var urlComponents = URLComponents()
        urlComponents.scheme = "http"
        urlComponents.host = "ec2-52-47-86-31.eu-west-3.compute.amazonaws.com"
        urlComponents.path = "/CreatePromoComentarios"
        let idPromocion = URLQueryItem(name: "idPromocion", value: String(self.promo.idPromocion))
        let idEstablecimiento = URLQueryItem(name: "idEstablecimiento", value: self.establecimientoId)
        let comentario = URLQueryItem(name: "comentario", value: self.tcomment.text)
        urlComponents.queryItems = [idPromocion,idEstablecimiento, comentario]
        guard let urle = urlComponents.url else { fatalError("Could not create URL from components") }
        
        var request = URLRequest(url: urle)
        request.httpMethod = "POST"
        
        let config = URLSessionConfiguration.default
        let session = URLSession(configuration: config)
        let task = session.dataTask(with: request) { (responseData, response, responseError) in
            DispatchQueue.main.async {
                if let jsonData = responseData {
                    // Now we have jsonData, Data representation of the JSON returned to us
                    // from our URLRequest...
                    print(jsonData.description)
                    let status = try? JSONDecoder().decode(PeticionStatus.self, from: jsonData)
                    if (status?.status == 200){
                        var line = ""
                        var urlComponents = URLComponents()
                        urlComponents.scheme = "http"
                        urlComponents.host = "ec2-52-47-86-31.eu-west-3.compute.amazonaws.com"
                        urlComponents.path = "/GetPromoComentarios"
                        let idFabItem = URLQueryItem(name: "idPromocion", value: String(self.promo.idPromocion))
                        urlComponents.queryItems = [idFabItem]
                        guard let urle = urlComponents.url else { fatalError("Could not create URL from components") }
                        
                        var request = URLRequest(url: urle)
                        request.httpMethod = "GET"
                        
                        let config = URLSessionConfiguration.default
                        let session = URLSession(configuration: config)
                        let task = session.dataTask(with: request) { (responseData, response, responseError) in
                            DispatchQueue.main.async {
                                if let jsonData = responseData {
                                    // Now we have jsonData, Data representation of the JSON returned to us
                                    // from our URLRequest...
                                    print(jsonData.description)
                                    let comentarios = try? JSONDecoder().decode([String:[Comments]].self, from: jsonData)
                                    if (comentarios!.count>0){
                                        for com in comentarios!{
                                            for comment in com.value{
                                                line += comment.nombre + ": " + comment.comentario + "\n"
                                            }
                                            
                                        }
                                        
                                        let attrStr = NSMutableAttributedString(string: line)
                                        let inputLength = attrStr.string.count
                                        var range = NSRange(location: 0, length: attrStr.length)
                                        
                                        for com in comentarios!{
                                            for comment in com.value{
                                                let searchString = comment.nombre + ": "
                                                let searchLength = searchString.count
                                                
                                                while (range.location != NSNotFound) {
                                                    range = (attrStr.string as NSString).range(of: searchString, options: [], range: range)
                                                    if (range.location != NSNotFound) {
                                                        attrStr.addAttribute(NSAttributedString.Key.font, value:UIFont.boldSystemFont(ofSize: 15), range: NSRange(location: range.location, length: searchLength))
                                                        range = NSRange(location: range.location + range.length, length: inputLength - (range.location + range.length))
                                                    }
                                                }
                                                
                                            }
                                            
                                        }
                                        
                                        self.comentarios.attributedText = attrStr
                                        self.tcomment.text = ""
                                        self.getPromoNumComments(numPromo: self.promo.idPromocion)
                                        
                                        
                                        
                                        /*for com in comentarios!{
                                         for comment in com.value{
                                         attributedString.addAttributes(boldFontAttribute, range: NSString(string: line).range(of: comment.nombre + ": "))
                                         }
                                         
                                         }
                                         self.tcomment.attributedText = attributedString*/
                                        
                                    }
                                    
                                    
                                }
                            }
                        }
                        
                        task.resume()
                        
                    }
                    else{
                        let alert = UIAlertController(title: "Error", message: "No se ha podido enviar comentario.", preferredStyle: UIAlertController.Style.alert)
                        alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                        alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                        self.present(alert, animated: true, completion: nil)
                    }
                    
                }
            }
        }
        
        task.resume()
        
        
        
        
        
        
        
    }
    
    @IBAction func returnActionForSegue(segue: UIStoryboardSegue) {
    }
    
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        if segue.identifier == "addPedido"{
            let vc = segue.destination as? AddPedidoTableViewController
            vc!.idEstablecimiento = establecimientoId
            vc!.idFabricante = String(promo.idFabricante)
            vc!.promo = promo
        }
    }

    @IBAction func addPedidoAction(_ sender: Any) {
        self.performSegue(withIdentifier: "addPedido", sender: nil)
    }
    
    
    
}
