//
//  DetalleFabTableViewController.swift
//  PromoHoreca
//
//  Created by Mireia Izquierdo aymerich on 9/12/18.
//  Copyright © 2018 Mireia Izquierdo aymerich. All rights reserved.
//

import UIKit
import AVFoundation
import AVKit

class DetalleFabTableViewController: UITableViewController {

    var promo:Promocion = Promocion(idPromocion: 0, idFabricante: 0, Nombre: "", Descripcion: "", PrecioUnitario: 0, FechaCaducidad: "", ArchivoAdjunto: "", Imagen: "", Zona:"",TipoProducto:"",TipoEstablecimiento:"")
    
    var numlikes = ""
    var numcomments = ""
    var numped = ""
    @IBOutlet weak var lnumped: UILabel!
    @IBOutlet weak var lnumcom: UILabel!
    @IBOutlet weak var lnumlikes: UILabel!
    @IBOutlet weak var mediaView: UIView!
    @IBOutlet weak var lstatus: UILabel!
    @IBOutlet weak var lprecio: UILabel!
    @IBOutlet weak var LFECHA: UILabel!
    @IBOutlet weak var ldesc: UITextView!
    @IBOutlet weak var ltipoest: UITextView!
    @IBOutlet weak var lzona: UITextView!
    @IBOutlet weak var ltipop: UILabel!
    @IBOutlet weak var tcomment: UITextView!
    private var activityIndicador:UIActivityIndicatorView = UIActivityIndicatorView()
    
    override func viewDidLoad() {
        super.viewDidLoad()
        self.activityIndicador.center=self.view.center
        self.activityIndicador.autoresizingMask = [.flexibleBottomMargin, .flexibleLeftMargin, .flexibleWidth, .flexibleRightMargin, .flexibleTopMargin, .flexibleHeight, .flexibleBottomMargin]
        self.activityIndicador.hidesWhenStopped = true
        self.activityIndicador.style = .gray
        self.view.addSubview(self.activityIndicador)
        
        self.title = promo.Nombre
        let url = URL(string: promo.Imagen)
        let imageData = NSData(contentsOf: url!)
        if let downloadedImageData = imageData{
            if (promo.Imagen.lowercased().hasSuffix(".jpeg")) || (promo.Imagen.lowercased().hasSuffix(".jpg")) || (promo.Imagen.lowercased().hasSuffix(".png")){
                let image = UIImage(data: downloadedImageData as Data)
                for subview in self.mediaView.subviews {
                subview.removeFromSuperview()
                }
                let vc = UIImageView()
                vc.image = image
                vc.frame = self.mediaView.bounds
                vc.autoresizingMask = [.flexibleWidth, .flexibleHeight]
                self.mediaView.autoresizesSubviews=true
                self.mediaView.addSubview(vc)
                


            }
            else if (promo.Imagen.lowercased().hasSuffix(".mov")) || (promo.Imagen.lowercased().hasSuffix(".avi")) || (promo.Imagen.lowercased().hasSuffix(".mp4")){
                let player = AVPlayer(url: url!)
                let vc = AVPlayerViewController()
                vc.player = player
                vc.view.frame = self.mediaView.bounds
                vc.showsPlaybackControls=true
                self.addChild(vc)
                vc.view.frame = self.mediaView.bounds
                vc.view.autoresizingMask = [.flexibleWidth, .flexibleHeight]
                self.mediaView.autoresizesSubviews=true
                self.mediaView.addSubview(vc.view)
             }

        }
        lnumcom.text = numcomments
        lnumlikes.text = numlikes
        lnumped.text = numped
        lprecio.text = String(promo.PrecioUnitario) + " €/Un."
        ltipop.text = promo.TipoProducto
        ltipoest.text = promo.TipoEstablecimiento.replacingOccurrences(of: "[", with: "").replacingOccurrences(of: "]", with: "").replacingOccurrences(of: "\"", with: "")
        lzona.text = promo.Zona.replacingOccurrences(of: "[", with: "").replacingOccurrences(of: "]", with: "").replacingOccurrences(of: "\"", with: "")
        
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "dd'-'MM'-'yyyy'"
        let date = dateFormatter.date(from: promo.FechaCaducidad)
        let now = Date()
        if (date == now || date! > now){
            lstatus.text = "ACTIVA"
            lstatus.textColor = UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
        }else{
            lstatus.text = "INACTIVA"
            lstatus.textColor = UIColor.red
        }
        LFECHA.text = promo.FechaCaducidad
        ldesc.text = promo.Descripcion
        
        var line = "";
        var urlComponents = URLComponents()
        urlComponents.scheme = "http"
        urlComponents.host = "ec2-52-47-86-31.eu-west-3.compute.amazonaws.com"
        urlComponents.path = "/GetPromoComentarios"
        let idFabItem = URLQueryItem(name: "idPromocion", value: String(promo.idPromocion))
        urlComponents.queryItems = [idFabItem]
        guard let urle = urlComponents.url else { fatalError("Could not create URL from components") }
        
        var request = URLRequest(url: urle)
        request.httpMethod = "GET"
        
        let config = URLSessionConfiguration.default
        let session = URLSession(configuration: config)
        let task = session.dataTask(with: request) { (responseData, response, responseError) in
            DispatchQueue.main.async {
                if let jsonData = responseData {
                    // Now we have jsonData, Data representation of the JSON returned to us
                    // from our URLRequest...
                    print(jsonData.description)
                    let comentarios = try? JSONDecoder().decode([String:[Comments]].self, from: jsonData)
                    if (comentarios!.count>0){
                        for com in comentarios!{
                            for comment in com.value{
                                line += comment.nombre + ": " + comment.comentario + "\n"
                            }
                            
                        }
                        
                        //let attributedString = NSMutableAttributedString(string: line as String, attributes: [NSAttributedString.Key.font:UIFont.systemFont(ofSize: 15.0)])
                        
                        //let boldFontAttribute = [NSAttributedString.Key.font: UIFont.boldSystemFont(ofSize: 15.0)]
                        
                        let attrStr = NSMutableAttributedString(string: line)
                        let inputLength = attrStr.string.count
                        var range = NSRange(location: 0, length: attrStr.length)
                        
                        for com in comentarios!{
                            for comment in com.value{
                                let searchString = comment.nombre + ": "
                                let searchLength = searchString.count
                                
                                while (range.location != NSNotFound) {
                                    range = (attrStr.string as NSString).range(of: searchString, options: [], range: range)
                                    if (range.location != NSNotFound) {
                                        attrStr.addAttribute(NSAttributedString.Key.font, value:UIFont.boldSystemFont(ofSize: 15), range: NSRange(location: range.location, length: searchLength))
                                        range = NSRange(location: range.location + range.length, length: inputLength - (range.location + range.length))
                                    }
                                }
                               
                            }
                            
                        }
                        
                        self.tcomment.attributedText = attrStr
                       
                        
                        
                        
                        /*for com in comentarios!{
                            for comment in com.value{
                                attributedString.addAttributes(boldFontAttribute, range: NSString(string: line).range(of: comment.nombre + ": "))
                            }
                            
                        }
                        self.tcomment.attributedText = attributedString*/
                        
                    }
                    
                
                }
            }
        }
        
        task.resume()
    }
    



    // MARK: - Table view data source

    override func numberOfSections(in tableView: UITableView) -> Int {
        // #warning Incomplete implementation, return the number of sections
        return 1
    }
    
    @IBAction func borrarPromo(_ sender: Any) {
        
        let alert = UIAlertController(title: "Eliminar promocion", message: "¿Está seguro de que quiere borrar la promoción?", preferredStyle: UIAlertController.Style.alert)
        let okAction = UIAlertAction(title: "OK", style: UIAlertAction.Style.default) {
            UIAlertAction in
            self.deletePromo()
        }
        alert.addAction(okAction)
        alert.addAction(UIAlertAction(title: "CANCEL", style: UIAlertAction.Style.default, handler: nil))
        alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
        self.present(alert, animated: true, completion: nil)
        
    }
    
    func deletePromo(){
        UIApplication.shared.beginIgnoringInteractionEvents()
        self.activityIndicador.startAnimating()
        var urlComponents = URLComponents()
        urlComponents.scheme = "http"
        urlComponents.host = "ec2-52-47-86-31.eu-west-3.compute.amazonaws.com"
        urlComponents.path = "/GetNumPedPromoFab"
        let idPromoItem = URLQueryItem(name: "idPromocion", value: String(promo.idPromocion))
        urlComponents.queryItems = [idPromoItem]
        guard let url = urlComponents.url else { fatalError("Could not create URL from components") }
        
        var request = URLRequest(url: url)
        request.httpMethod = "GET"
        
        let config = URLSessionConfiguration.default
        let session = URLSession(configuration: config)
        let task = session.dataTask(with: request) { (responseData, response, responseError) in
            DispatchQueue.main.async {
                if let error = responseError {
                    print(error)
                    UIApplication.shared.endIgnoringInteractionEvents()
                    self.activityIndicador.stopAnimating()
                    let alert = UIAlertController(title: "Error", message: "No se ha podido obtener el numero de pedidos de la promoción.", preferredStyle: UIAlertController.Style.alert)
                    alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                    alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                    self.present(alert, animated: true, completion: nil)
                } else if let jsonData = responseData {
                    // Now we have jsonData, Data representation of the JSON returned to us
                    // from our URLRequest...
                    print(jsonData.description)
                    guard let num = try? JSONDecoder().decode(Count.self, from: jsonData) else {
                        UIApplication.shared.endIgnoringInteractionEvents()
                        self.activityIndicador.stopAnimating()
                        let alert = UIAlertController(title: "Error", message: "No se ha podido obtener el numero de pedidos de la promoción.", preferredStyle: UIAlertController.Style.alert)
                        alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                        alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                        self.present(alert, animated: true, completion: nil)
                        return
                    }
                    if (num.count > 0 ){
                        UIApplication.shared.endIgnoringInteractionEvents()
                        self.activityIndicador.stopAnimating()
                        let alert = UIAlertController(title: "Error", message: "No se ha podido eliminar la promoción ya que existen pedidos relacionados con ella.", preferredStyle: UIAlertController.Style.alert)
                        alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                        alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                        self.present(alert, animated: true, completion: nil)
                        
                    }else{
                        var urlComponents1 = URLComponents()
                        urlComponents1.scheme = "http"
                        urlComponents1.host = "ec2-52-47-86-31.eu-west-3.compute.amazonaws.com"
                        urlComponents1.path = "/DeletePromocion"
                        let idFabItem = URLQueryItem(name: "idPromocion", value: String(self.promo.idPromocion))
                        urlComponents1.queryItems = [idFabItem]
                        guard let url = urlComponents1.url else { fatalError("Could not create URL from components") }
                        
                        var request = URLRequest(url: url)
                        request.httpMethod = "POST"
                        
                        let config = URLSessionConfiguration.default
                        let session = URLSession(configuration: config)
                        let task = session.dataTask(with: request) { (responseData, response, responseError) in
                            DispatchQueue.main.async {
                                if let error = responseError {
                                    print(error)
                                    UIApplication.shared.endIgnoringInteractionEvents()
                                    self.activityIndicador.stopAnimating()
                                    let alert = UIAlertController(title: "Error", message: "No se ha podido eliminar la promoción.", preferredStyle: UIAlertController.Style.alert)
                                    alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                                    alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                                    self.present(alert, animated: true, completion: nil)
                                } else if let jsonData = responseData {
                                    // Now we have jsonData, Data representation of the JSON returned to us
                                    // from our URLRequest...
                                    print(jsonData.description)
                                    guard let peticion = try? JSONDecoder().decode(PeticionStatus.self, from: jsonData) else {
                                        UIApplication.shared.endIgnoringInteractionEvents()
                                        self.activityIndicador.stopAnimating()
                                        let alert = UIAlertController(title: "Error", message: "No se ha podido eliminar la promoción.", preferredStyle: UIAlertController.Style.alert)
                                        alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                                        alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                                        self.present(alert, animated: true, completion: nil)
                                        return
                                    }
                                    if ( peticion.status==200){
                                        UIApplication.shared.endIgnoringInteractionEvents()
                                        self.activityIndicador.stopAnimating()
                                        let alert = UIAlertController(title: "Promocion eliminada", message: "La promoción se ha eliminado", preferredStyle: UIAlertController.Style.alert)
                                        let okAction = UIAlertAction(title: "OK", style: UIAlertAction.Style.default) {
                                            UIAlertAction in
                                            self.performSegue(withIdentifier: "backtoPromoList", sender: nil)
                                        }
                                        alert.addAction(okAction)
                                        alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                                        self.present(alert, animated: true, completion: nil)
                                        return
                                    }else{
                                        UIApplication.shared.endIgnoringInteractionEvents()
                                        self.activityIndicador.stopAnimating()
                                        let alert = UIAlertController(title: "Error", message: "No se ha podido eliminar la promoción.", preferredStyle: UIAlertController.Style.alert)
                                        alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                                        alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                                        self.present(alert, animated: true, completion: nil)
                                        return
                                    }
                                }
                            }
                            
                        }
                        task.resume()
                    }
                    
                } else {
                    let error = NSError(domain: "", code: 0, userInfo: [NSLocalizedDescriptionKey : "Data was not retrieved from request"]) as Error
                    print(error)
                    UIApplication.shared.endIgnoringInteractionEvents()
                    self.activityIndicador.stopAnimating()
                    let alert = UIAlertController(title: "Error", message: "No se han podido obtener el numero de pedidos del distribuidor.", preferredStyle: UIAlertController.Style.alert)
                    alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                    alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                    self.present(alert, animated: true, completion: nil)
                }
            }
        }
        
        task.resume()
    }
    

}
