//
//  DetallePedidoEstabTableViewController.swift
//  PromoHoreca
//
//  Created by Mireia Izquierdo aymerich on 29/12/18.
//  Copyright © 2018 Mireia Izquierdo aymerich. All rights reserved.
//

import UIKit
import MapKit
import AVKit
import AVFoundation

class DetallePedidoEstabTableViewController: UITableViewController {

        var pedido:Pedidos = Pedidos(idPedido: "", idPromocion: "", PromocionNombre: "", PromoImagen:"", Precio: "", Cantidad: "", Importe: "", PromoDescripcion: "", idFabricante: "", FabNombre: "", FabTelefono: "", idDistribuidor: "", DistNombre: "", DistDireccion: "", DistCiudad: "", DistCPostal: "", DistTelefono: "", DistZona: "", DistGeoposicion: "", idEstablecimiento: "", EstabNombre: "", EstabDireccion: "", EstabCiudad: "", EstabCPostal: "", EstabTelefono: "", EstabZona: "")
    
    
    @IBOutlet weak var mapview: MKMapView!
    @IBOutlet weak var telefonodistri: UILabel!
    @IBOutlet weak var zonadistri: UILabel!
    @IBOutlet weak var ciudaddistri: UILabel!
    @IBOutlet weak var dirdistri: UILabel!
    @IBOutlet weak var nomdistri: UILabel!
    @IBOutlet weak var telefonofab: UILabel!
    @IBOutlet weak var nomfab: UILabel!
    @IBOutlet weak var importe: UILabel!
    @IBOutlet weak var cantidad: UILabel!
    @IBOutlet weak var descripcion: UITextView!
    @IBOutlet weak var nombre: UILabel!
    @IBOutlet weak var imgview: UIView!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        self.title = "Pedido #" + pedido.idPedido
        let url = URL(string: pedido.PromoImagen)
        let imageData = NSData(contentsOf: url!)
        if let downloadedImageData = imageData{
            if (pedido.PromoImagen.lowercased().hasSuffix(".jpeg")) || (pedido.PromoImagen.lowercased().hasSuffix(".jpg")) || (pedido.PromoImagen.lowercased().hasSuffix(".png")){
                let image = UIImage(data: downloadedImageData as Data)
                for subview in self.imgview.subviews {
                    subview.removeFromSuperview()
                }
                let vc = UIImageView()
                vc.image = image
                vc.frame = self.imgview.bounds
                vc.autoresizingMask = [.flexibleWidth, .flexibleHeight]
                self.imgview.autoresizesSubviews=true
                self.imgview.addSubview(vc)
                
                
                
            }
            else if (pedido.PromoImagen.lowercased().hasSuffix(".mov")) || (pedido.PromoImagen.lowercased().hasSuffix(".avi")) || (pedido.PromoImagen.lowercased().hasSuffix(".mp4")){
                let player = AVPlayer(url: url!)
                let vc = AVPlayerViewController()
                vc.player = player
                vc.view.frame = self.imgview.bounds
                vc.showsPlaybackControls=true
                self.addChild(vc)
                vc.view.frame = self.imgview.bounds
                vc.view.autoresizingMask = [.flexibleWidth, .flexibleHeight]
                self.imgview.autoresizesSubviews=true
                self.imgview.addSubview(vc.view)
            }
        }
        
        nombre.text = pedido.PromocionNombre
        cantidad.text = pedido.Cantidad
        importe.text = pedido.Importe + " €"
        descripcion.text = pedido.PromoDescripcion
        nomfab.text = pedido.FabNombre
        telefonofab.text = pedido.FabTelefono
        nomdistri.text = pedido.DistNombre
        dirdistri.text = pedido.DistDireccion
        ciudaddistri.text = pedido.DistCiudad + ", " + pedido.DistCPostal
        zonadistri.text = pedido.DistZona
        telefonodistri.text = pedido.DistTelefono
        
        let distribuidor = MKPointAnnotation()
        distribuidor.title = pedido.DistNombre
        distribuidor.coordinate = CLLocationCoordinate2D(latitude: Double(pedido.DistGeoposicion.replacingOccurrences(of: "{", with: "").replacingOccurrences(of: "}", with: "").split(separator: ",")[0])!, longitude: Double(pedido.DistGeoposicion.replacingOccurrences(of: "{", with: "").replacingOccurrences(of: "}", with: "").split(separator: ",")[1])!)
        mapview.addAnnotation(distribuidor)
        let center = CLLocationCoordinate2D(latitude: Double(pedido.DistGeoposicion.replacingOccurrences(of: "{", with: "").replacingOccurrences(of: "}", with: "").split(separator: ",")[0])!, longitude: Double(pedido.DistGeoposicion.replacingOccurrences(of: "{", with: "").replacingOccurrences(of: "}", with: "").split(separator: ",")[1])!)
        var region = MKCoordinateRegion(center: center, span: MKCoordinateSpan(latitudeDelta: 0.05, longitudeDelta: 0.05))
        region.center = center
        mapview.setRegion(region, animated: true)
        

    }

    // MARK: - Table view data source

    override func numberOfSections(in tableView: UITableView) -> Int {
        // #warning Incomplete implementation, return the number of sections
        return 1
    }


}
