//
//  DetallePedidoFabTableViewController.swift
//  PromoHoreca
//
//  Created by Mireia Izquierdo aymerich on 29/12/18.
//  Copyright © 2018 Mireia Izquierdo aymerich. All rights reserved.
//

import UIKit
import AVKit
import AVFoundation

class DetallePedidoFabTableViewController: UITableViewController {
    
    var pedido:Pedidos = Pedidos(idPedido: "", idPromocion: "", PromocionNombre: "", PromoImagen:"", Precio: "", Cantidad: "", Importe: "", PromoDescripcion: "", idFabricante: "", FabNombre: "", FabTelefono: "", idDistribuidor: "", DistNombre: "", DistDireccion: "", DistCiudad: "", DistCPostal: "", DistTelefono: "", DistZona: "", DistGeoposicion: "", idEstablecimiento: "", EstabNombre: "", EstabDireccion: "", EstabCiudad: "", EstabCPostal: "", EstabTelefono: "", EstabZona: "")

    @IBOutlet weak var imgview: UIView!
    @IBOutlet weak var nompromo: UILabel!
    @IBOutlet weak var descpromo: UITextView!
    @IBOutlet weak var estabtelefono: UILabel!
    @IBOutlet weak var estabzona: UILabel!
    @IBOutlet weak var estabciudad: UILabel!
    @IBOutlet weak var estabdir: UILabel!
    @IBOutlet weak var estabnom: UILabel!
    @IBOutlet weak var distritelf: UILabel!
    @IBOutlet weak var distriname: UILabel!
    @IBOutlet weak var importe: UILabel!
    @IBOutlet weak var cantidad: UILabel!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        self.title = "Pedido #" + pedido.idPedido
        let url = URL(string: pedido.PromoImagen)
        let imageData = NSData(contentsOf: url!)
        if let downloadedImageData = imageData{
            if (pedido.PromoImagen.lowercased().hasSuffix(".jpeg")) || (pedido.PromoImagen.lowercased().hasSuffix(".jpg")) || (pedido.PromoImagen.lowercased().hasSuffix(".png")){
                let image = UIImage(data: downloadedImageData as Data)
                for subview in self.imgview.subviews {
                    subview.removeFromSuperview()
                }
                let vc = UIImageView()
                vc.image = image
                vc.frame = self.imgview.bounds
                vc.autoresizingMask = [.flexibleWidth, .flexibleHeight]
                self.imgview.autoresizesSubviews=true
                self.imgview.addSubview(vc)
                
                
                
            }
            else if (pedido.PromoImagen.lowercased().hasSuffix(".mov")) || (pedido.PromoImagen.lowercased().hasSuffix(".avi")) || (pedido.PromoImagen.lowercased().hasSuffix(".mp4")){
                let player = AVPlayer(url: url!)
                let vc = AVPlayerViewController()
                vc.player = player
                vc.view.frame = self.imgview.bounds
                vc.showsPlaybackControls=true
                self.addChild(vc)
                vc.view.frame = self.imgview.bounds
                vc.view.autoresizingMask = [.flexibleWidth, .flexibleHeight]
                self.imgview.autoresizesSubviews=true
                self.imgview.addSubview(vc.view)
            }
        }
        
        nompromo.text = pedido.PromocionNombre
        cantidad.text = pedido.Cantidad
        importe.text = pedido.Importe + " €"
        descpromo.text = pedido.PromoDescripcion
        distriname.text = pedido.DistNombre
        distritelf.text = pedido.DistTelefono
        estabnom.text = pedido.EstabNombre
        estabdir.text = pedido.EstabDireccion
        estabciudad.text = pedido.EstabCiudad + ", " + pedido.EstabCPostal
        estabzona.text = pedido.EstabZona
        estabtelefono.text = pedido.EstabTelefono

    }

    

    override func numberOfSections(in tableView: UITableView) -> Int {
        // #warning Incomplete implementation, return the number of sections
        return 1
    }

    
}
