//
//  EditPerfilEstabTableViewController.swift
//  PromoHoreca
//
//  Created by Mireia Izquierdo aymerich on 24/12/18.
//  Copyright © 2018 Mireia Izquierdo aymerich. All rights reserved.
//

import UIKit

class EditPerfilEstabTableViewController: UITableViewController, UITextFieldDelegate,UIPickerViewDelegate,UIPickerViewDataSource {

    @IBOutlet weak var pCong: UISwitch!
    @IBOutlet weak var pSnacks: UISwitch!
    @IBOutlet weak var pLact: UISwitch!
    @IBOutlet weak var pBebAlc: UISwitch!
    @IBOutlet weak var pBebSAlc: UISwitch!
    @IBOutlet weak var pAlim: UISwitch!
    @IBOutlet weak var tipopicker: UIPickerView!
    @IBOutlet weak var zonapicker: UIPickerView!
    @IBOutlet weak var ciudad: UITextField!
    @IBOutlet weak var direccion: UITextField!
    @IBOutlet weak var cpostal: UITextField!
    @IBOutlet weak var telefono: UITextField!
    @IBOutlet weak var nif: UITextField!
    @IBOutlet weak var nombre: UITextField!
    var perfilusuario:PerfilEstab = PerfilEstab(status: 0, idEstablecimiento: "", nombre: "", nif: "", telefono: "", direccion: "", ciudad: "", cpostal: "", preferencias: "", tipoestablecimiento: "", zona: "")
    let zona = [["Zona", "Noreste y Baleares", "Levante","Sur","Centro","Noroeste","Norte","Canarias"]]
    let tipo = [["Tipo de establecimiento", "Restaurante", "Cafeteria", "Hotel", "Gasolinera", "Alimentación tradicional", "Quiosco","Ocio nocturno", "Tenda de Snacks", "Restauración social"]]
    var zonaSelected: String = ""
    var tipoSelected: String = ""
    private var indicador: UIActivityIndicatorView = UIActivityIndicatorView()
    
    override func viewDidLoad() {
        super.viewDidLoad()
        nombre.delegate = self
        nif.delegate = self
        telefono.delegate = self
        cpostal.delegate = self
        direccion.delegate = self
        ciudad.delegate = self
        self.zonapicker.delegate=self
        self.zonapicker.dataSource=self
        self.tipopicker.delegate=self
        self.tipopicker.dataSource=self
        
        self.indicador.center=self.view.center
        self.indicador.autoresizingMask = [.flexibleBottomMargin, .flexibleLeftMargin, .flexibleWidth, .flexibleRightMargin, .flexibleTopMargin, .flexibleHeight, .flexibleBottomMargin]
        self.indicador.hidesWhenStopped = true
        self.indicador.style = .gray
        self.view.addSubview(self.indicador)
        
        nombre.text = perfilusuario.nombre
        nif.text = perfilusuario.nif
        telefono.text = perfilusuario.telefono
        cpostal.text = perfilusuario.cpostal
        direccion.text = perfilusuario.direccion
        ciudad.text = perfilusuario.ciudad
        
        if perfilusuario.preferencias.contains("Alimentación"){
            pAlim.setOn(true, animated: false)
        }
        
        if perfilusuario.preferencias.contains("Bebidas sin alcohol"){
            pBebSAlc.setOn(true, animated: false)
        }
        
        if perfilusuario.preferencias.contains("Bebidas con alcohol"){
            pBebAlc.setOn(true, animated: false)
        }
        
        if perfilusuario.preferencias.contains("Lácteos"){
            pLact.setOn(true, animated: false)
        }
        
        if perfilusuario.preferencias.contains("Congelados"){
            pCong.setOn(true, animated: false)
        }
        
        if perfilusuario.preferencias.contains("Snacks"){
            pSnacks.setOn(true, animated: false)
        }
        
        zonapicker.selectRow(zona[0].firstIndex(of: perfilusuario.zona)!, inComponent: 0, animated: false)
        zonaSelected = perfilusuario.zona
        tipopicker.selectRow(tipo[0].firstIndex(of: perfilusuario.tipoestablecimiento)!, inComponent: 0, animated: false)
        tipoSelected = perfilusuario.tipoestablecimiento
    }

    func numberOfComponents(in pickerView: UIPickerView) -> Int {
    return 1
    }
    
    func pickerView(_ pickerView: UIPickerView, numberOfRowsInComponent component: Int) -> Int {
        
        if pickerView == zonapicker
        {
            return zona[0].count
        }
        else if pickerView == tipopicker
        {
            return tipo[0].count
        }
        return 0
    }
    
    func pickerView(_ pickerView: UIPickerView, titleForRow row: Int, forComponent component: Int) -> String? {
        if pickerView == zonapicker
        {
            return zona[component][row]
        }
        else if pickerView == tipopicker
        {
            return tipo[component][row]
        }
        return ""
    }
    
    func pickerView(_ pickerView: UIPickerView, didSelectRow row: Int, inComponent component: Int) {
        
        if pickerView == zonapicker
        {
            zonaSelected = zona[0][row]
        }
        else if pickerView == tipopicker
        {
            tipoSelected = tipo[0][row]
        }
        
        // now, every time someone changes the Picker View's value, fruitSelected will be whatever they chose.
    }
    
    override func viewDidLayoutSubviews() {
        super.viewDidLayoutSubviews()
    }
    
    @IBAction func guardarAction(_ sender: Any) {
        UIApplication.shared.beginIgnoringInteractionEvents()
        indicador.startAnimating()
        
        if nombre.text == "" || nif.text == "" || telefono.text == "" || direccion.text == "" || ciudad.text == "" || cpostal.text == ""
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "Hay que completar todos los campos del perfil.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        if !isValidNIF(testStr:nif.text!)
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "El formato del campo NIF es incorrecto.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else if !isValidCpostal(testStr:cpostal.text!)
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "El formato del campo codigo postal es incorrecto.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else if !isValidTelefono(testStr:telefono.text!)
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "El formato del campo teléfono es incorrecto.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else if pAlim.isOn==false && pLact.isOn==false && pBebAlc.isOn==false && pBebSAlc.isOn==false && pCong.isOn==false && pSnacks.isOn==false
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "Se debe seleccionar almenos un tipo de producto.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else if zonaSelected.isEmpty || zonaSelected == "Zona"
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "Se debe seleccionar una zona.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else if tipoSelected.isEmpty || tipoSelected == "Tipo de establecimiento"
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "Se debe seleccionar un tipo de establecimiento.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else
        {
            
            var urlComponents = URLComponents()
            urlComponents.scheme = "http"
            urlComponents.host = "ec2-52-47-86-31.eu-west-3.compute.amazonaws.com"
            urlComponents.path = "/ModifyEstab"
            var preferencias = ""
            if (self.pAlim.isOn && preferencias.isEmpty)
            {
                preferencias = "Alimentación"
                
            }else if (self.pAlim.isOn && !preferencias.isEmpty)
            {
                preferencias = preferencias + "," +  "Alimentación"
            }
            
            if (self.pBebAlc.isOn && preferencias.isEmpty)
            {
                preferencias = "Bebidas con alcohol"
                
            }else if (self.pBebAlc.isOn && !preferencias.isEmpty)
            {
                preferencias = preferencias + "," +  "Bebidas con alcohol"
            }
            
            if (self.pBebSAlc.isOn && preferencias.isEmpty)
            {
                preferencias = "Bebidas sin alcohol"
                
            }else if (self.pBebSAlc.isOn && !preferencias.isEmpty)
            {
                preferencias = preferencias + "," +  "Bebidas sin alcohol"
            }
            
            if (self.pLact.isOn && preferencias.isEmpty)
            {
                preferencias = "Lácteos"
                
            }else if (self.pLact.isOn && !preferencias.isEmpty)
            {
                preferencias = preferencias + "," +  "Lácteos"
            }
            
            if (self.pSnacks.isOn && preferencias.isEmpty)
            {
                preferencias = "Snacks"
                
            }else if (self.pSnacks.isOn && !preferencias.isEmpty)
            {
                preferencias = preferencias + "," +  "Snacks"
            }
            
            if (self.pCong.isOn && preferencias.isEmpty)
            {
                preferencias = "Congelados"
                
            }else if (self.pCong.isOn && !preferencias.isEmpty)
            {
                preferencias = preferencias + "," +  "Congelados"
            }
            
            preferencias = "{" + preferencias + "}"
            
            let preferenciasItem = URLQueryItem(name: "preferencias", value: preferencias)
            let tipoestabItem = URLQueryItem(name: "tipoestab", value: self.tipoSelected)
            let zonaItem = URLQueryItem(name: "zona", value: self.zonaSelected)
            let nameItem = URLQueryItem(name: "nombre", value: nombre.text)
            let nifItem = URLQueryItem(name: "nif", value: nif.text)
            let telefonoItem = URLQueryItem(name: "telefono", value: telefono.text)
            let direccionItem = URLQueryItem(name: "direccion", value: direccion.text)
            let ciudadItem = URLQueryItem(name: "ciudad", value: ciudad.text)
            let cpostalItem = URLQueryItem(name: "cpostal", value: cpostal.text)
            let iditem = URLQueryItem(name:"idusuario", value: perfilusuario.idEstablecimiento)
            
            urlComponents.queryItems = [iditem,nameItem, nifItem, telefonoItem, ciudadItem, cpostalItem, direccionItem, tipoestabItem, zonaItem,preferenciasItem]
            guard let url = urlComponents.url else { fatalError("Could not create URL from components") }
            
            var request = URLRequest(url: url)
            request.httpMethod = "POST"
            let config = URLSessionConfiguration.default
            let session = URLSession(configuration: config)
            let task = session.dataTask(with: request) { (responseData, response, responseError) in
                DispatchQueue.main.async {
                    if let error = responseError {
                        print(error)
                        UIApplication.shared.endIgnoringInteractionEvents()
                        self.indicador.stopAnimating()
                        let alert = UIAlertController(title: "Error", message: "No se ha podido actualizar el perfil de usuario, no se han podido insertar los datos del sistema.", preferredStyle: UIAlertController.Style.alert)
                        alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                        alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                        self.present(alert, animated: true, completion: nil)
                    } else if let jsonData = responseData {
                        // Now we have jsonData, Data representation of the JSON returned to us
                        // from our URLRequest...
                        print(jsonData.description)
                        guard let usuarioreg = try? JSONDecoder().decode(UsuarioReg.self, from: jsonData) else {
                            UIApplication.shared.endIgnoringInteractionEvents()
                            self.indicador.stopAnimating()
                            let alert = UIAlertController(title: "Error", message: "No se ha podido actualizar el perfil de usuario, no se han podido insertar los datos del sistema.", preferredStyle: UIAlertController.Style.alert)
                            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                            self.present(alert, animated: true, completion: nil)
                            return
                        }
                        if (usuarioreg.status==200){
                            UIApplication.shared.endIgnoringInteractionEvents()
                            self.indicador.stopAnimating()
                            let alert = UIAlertController(title: "Usuario actualizado", message: "El usuario se ha actualizado con exito.", preferredStyle: UIAlertController.Style.alert)
                            let okAction = UIAlertAction(title: "OK", style: UIAlertAction.Style.default) {
                                UIAlertAction in
                                self.performSegue(withIdentifier: "backtoPerfil", sender: nil)
                            }
                            alert.addAction(okAction)
                            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                            self.present(alert, animated: true, completion: nil)
                            
                            
                        }
                        else{
                            UIApplication.shared.endIgnoringInteractionEvents()
                            self.indicador.stopAnimating()
                            let alert = UIAlertController(title: "Error", message: "No se ha podido registrar el usuario, no se han podido insertar los datos del sistema.", preferredStyle: UIAlertController.Style.alert)
                            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                            self.present(alert, animated: true, completion: nil)
                        }
                        
                    } else {
                        let error = NSError(domain: "", code: 0, userInfo: [NSLocalizedDescriptionKey : "Data was not retrieved from request"]) as Error
                        print(error)
                        UIApplication.shared.endIgnoringInteractionEvents()
                        self.indicador.stopAnimating()
                        let alert = UIAlertController(title: "Error", message: "No se ha podido registrar el usuario, no se han podido insertar los datos del sistema.", preferredStyle: UIAlertController.Style.alert)
                        alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                        alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                        self.present(alert, animated: true, completion: nil)
                    }
                }
            }
            
            task.resume()
        }
    }
    
    
    func isValidNIF(testStr:String) -> Bool {
        let nifRegEx="^[0-9]{8}[TRWAGMYFPDXBNJZSQVHLCKET]{1}$"
        let nifTest = NSPredicate(format:"SELF MATCHES %@", nifRegEx)
        return nifTest.evaluate(with: testStr)
    }
    
    func isValidTelefono(testStr:String) -> Bool{
        let telfRegEx="^[9|6|7][0-9]{8}$"
        let telfTest = NSPredicate(format:"SELF MATCHES %@", telfRegEx)
        return telfTest.evaluate(with:testStr)
    }
    
    func isValidCpostal(testStr:String) -> Bool{
        let cpostalRegEx="^[0-9]{5}$"
        let cpostalTest = NSPredicate(format:"SELF MATCHES %@", cpostalRegEx)
        return cpostalTest.evaluate(with:testStr)
    }

}
