//
//  EditPerfilFabTableViewController.swift
//  PromoHoreca
//
//  Created by Mireia Izquierdo aymerich on 25/12/18.
//  Copyright © 2018 Mireia Izquierdo aymerich. All rights reserved.
//

import UIKit

class EditPerfilFabTableViewController: UITableViewController, UITextFieldDelegate {
    
    @IBOutlet weak var fSnacks: UISwitch!
    @IBOutlet weak var fCong: UISwitch!
    @IBOutlet weak var fLact: UISwitch!
    @IBOutlet weak var fBebAlc: UISwitch!
    @IBOutlet weak var fBebSAlc: UISwitch!
    @IBOutlet weak var fAlim: UISwitch!
    @IBOutlet weak var fcpostal: UITextField!
    @IBOutlet weak var fciudad: UITextField!
    @IBOutlet weak var fdireccion: UITextField!
    @IBOutlet weak var fnif: UITextField!
    @IBOutlet weak var ftelefono: UITextField!
    @IBOutlet weak var fnombre: UITextField!
    var perfilusuario: PerfilFab = PerfilFab(status: 0, idFabricante: "", nombre: "", nif: "", telefono: "", direccion: "", ciudad: "", cpostal: "", preferencias: "")
     private var indicador: UIActivityIndicatorView = UIActivityIndicatorView()
    
    override func viewDidLoad() {
        super.viewDidLoad()
       
        fnombre.delegate = self
        fnif.delegate = self
        ftelefono.delegate = self
        fcpostal.delegate = self
        fdireccion.delegate = self
        fciudad.delegate = self
        
        self.indicador.center=self.view.center
        self.indicador.autoresizingMask = [.flexibleBottomMargin, .flexibleLeftMargin, .flexibleWidth, .flexibleRightMargin, .flexibleTopMargin, .flexibleHeight, .flexibleBottomMargin]
        self.indicador.hidesWhenStopped = true
        self.indicador.style = .gray
        self.view.addSubview(self.indicador)
        
        fnombre.text = perfilusuario.nombre
        fnif.text = perfilusuario.nif
        ftelefono.text = perfilusuario.telefono
        fcpostal.text = perfilusuario.cpostal
        fdireccion.text = perfilusuario.direccion
        fciudad.text = perfilusuario.ciudad
        
        if perfilusuario.preferencias.contains("Alimentación"){
            fAlim.setOn(true, animated: false)
        }
        
        if perfilusuario.preferencias.contains("Bebidas sin alcohol"){
            fBebSAlc.setOn(true, animated: false)
        }
        
        if perfilusuario.preferencias.contains("Bebidas con alcohol"){
            fBebAlc.setOn(true, animated: false)
        }
        
        if perfilusuario.preferencias.contains("Lácteos"){
            fLact.setOn(true, animated: false)
        }
        
        if perfilusuario.preferencias.contains("Congelados"){
            fCong.setOn(true, animated: false)
        }
        
        if perfilusuario.preferencias.contains("Snacks"){
            fSnacks.setOn(true, animated: false)
        }
       
    }

    override func viewDidLayoutSubviews() {
        super.viewDidLayoutSubviews()
    }

    @IBAction func guardarFabAction(_ sender: Any) {
        
        UIApplication.shared.beginIgnoringInteractionEvents()
        indicador.startAnimating()
        
        if fnombre.text == "" || fnif.text == "" || ftelefono.text == "" || fdireccion.text == "" || fciudad.text == "" || fcpostal.text == ""
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "Hay que completar todos los campos del perfil.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        if !isValidNIF(testStr:fnif.text!)
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "El formato del campo NIF es incorrecto.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else if !isValidCpostal(testStr:fcpostal.text!)
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "El formato del campo codigo postal es incorrecto.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else if !isValidTelefono(testStr:ftelefono.text!)
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "El formato del campo teléfono es incorrecto.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else if fAlim.isOn==false && fLact.isOn==false && fBebAlc.isOn==false && fBebSAlc.isOn==false && fCong.isOn==false && fSnacks.isOn==false
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "Se debe seleccionar almenos un tipo de producto.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else
        {
            
            var urlComponents = URLComponents()
            urlComponents.scheme = "http"
            urlComponents.host = "ec2-52-47-86-31.eu-west-3.compute.amazonaws.com"
            urlComponents.path = "/ModifyFab"
            var preferencias = ""
            if (self.fAlim.isOn && preferencias.isEmpty)
            {
                preferencias = "Alimentación"
                
            }else if (self.fAlim.isOn && !preferencias.isEmpty)
            {
                preferencias = preferencias + "," +  "Alimentación"
            }
            
            if (self.fBebAlc.isOn && preferencias.isEmpty)
            {
                preferencias = "Bebidas con alcohol"
                
            }else if (self.fBebAlc.isOn && !preferencias.isEmpty)
            {
                preferencias = preferencias + "," +  "Bebidas con alcohol"
            }
            
            if (self.fBebSAlc.isOn && preferencias.isEmpty)
            {
                preferencias = "Bebidas sin alcohol"
                
            }else if (self.fBebSAlc.isOn && !preferencias.isEmpty)
            {
                preferencias = preferencias + "," +  "Bebidas sin alcohol"
            }
            
            if (self.fLact.isOn && preferencias.isEmpty)
            {
                preferencias = "Lácteos"
                
            }else if (self.fLact.isOn && !preferencias.isEmpty)
            {
                preferencias = preferencias + "," +  "Lácteos"
            }
            
            if (self.fSnacks.isOn && preferencias.isEmpty)
            {
                preferencias = "Snacks"
                
            }else if (self.fSnacks.isOn && !preferencias.isEmpty)
            {
                preferencias = preferencias + "," +  "Snacks"
            }
            
            if (self.fCong.isOn && preferencias.isEmpty)
            {
                preferencias = "Congelados"
                
            }else if (self.fCong.isOn && !preferencias.isEmpty)
            {
                preferencias = preferencias + "," +  "Congelados"
            }
            
            preferencias = "{" + preferencias + "}"
            
            let preferenciasItem = URLQueryItem(name: "preferencias", value: preferencias)
            let nameItem = URLQueryItem(name: "nombre", value: fnombre.text)
            let nifItem = URLQueryItem(name: "nif", value: fnif.text)
            let telefonoItem = URLQueryItem(name: "telefono", value: ftelefono.text)
            let direccionItem = URLQueryItem(name: "direccion", value: fdireccion.text)
            let ciudadItem = URLQueryItem(name: "ciudad", value: fciudad.text)
            let cpostalItem = URLQueryItem(name: "cpostal", value: fcpostal.text)
            let iditem = URLQueryItem(name:"idusuario", value: perfilusuario.idFabricante)
            
            urlComponents.queryItems = [iditem,nameItem, nifItem, telefonoItem, ciudadItem, cpostalItem, direccionItem, preferenciasItem]
            guard let url = urlComponents.url else { fatalError("Could not create URL from components") }
            
            var request = URLRequest(url: url)
            request.httpMethod = "POST"
            let config = URLSessionConfiguration.default
            let session = URLSession(configuration: config)
            let task = session.dataTask(with: request) { (responseData, response, responseError) in
                DispatchQueue.main.async {
                    if let error = responseError {
                        print(error)
                        UIApplication.shared.endIgnoringInteractionEvents()
                        self.indicador.stopAnimating()
                        let alert = UIAlertController(title: "Error", message: "No se ha podido actualizar el perfil de usuario, no se han podido insertar los datos del sistema.", preferredStyle: UIAlertController.Style.alert)
                        alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                        alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                        self.present(alert, animated: true, completion: nil)
                    } else if let jsonData = responseData {
                        // Now we have jsonData, Data representation of the JSON returned to us
                        // from our URLRequest...
                        print(jsonData.description)
                        guard let usuarioreg = try? JSONDecoder().decode(UsuarioReg.self, from: jsonData) else {
                            UIApplication.shared.endIgnoringInteractionEvents()
                            self.indicador.stopAnimating()
                            let alert = UIAlertController(title: "Error", message: "No se ha podido actualizar el perfil de usuario, no se han podido insertar los datos del sistema.", preferredStyle: UIAlertController.Style.alert)
                            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                            self.present(alert, animated: true, completion: nil)
                            return
                        }
                        if (usuarioreg.status==200){
                            UIApplication.shared.endIgnoringInteractionEvents()
                            self.indicador.stopAnimating()
                            let alert = UIAlertController(title: "Usuario actualizado", message: "El usuario se ha actualizado con exito.", preferredStyle: UIAlertController.Style.alert)
                            let okAction = UIAlertAction(title: "OK", style: UIAlertAction.Style.default) {
                                UIAlertAction in
                                self.performSegue(withIdentifier: "backtoFab", sender: nil)
                            }
                            alert.addAction(okAction)
                            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                            self.present(alert, animated: true, completion: nil)
                            
                            
                        }
                        else{
                            UIApplication.shared.endIgnoringInteractionEvents()
                            self.indicador.stopAnimating()
                            let alert = UIAlertController(title: "Error", message: "No se ha podido registrar el usuario, no se han podido insertar los datos del sistema.", preferredStyle: UIAlertController.Style.alert)
                            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                            self.present(alert, animated: true, completion: nil)
                        }
                        
                    } else {
                        let error = NSError(domain: "", code: 0, userInfo: [NSLocalizedDescriptionKey : "Data was not retrieved from request"]) as Error
                        print(error)
                        UIApplication.shared.endIgnoringInteractionEvents()
                        self.indicador.stopAnimating()
                        let alert = UIAlertController(title: "Error", message: "No se ha podido registrar el usuario, no se han podido insertar los datos del sistema.", preferredStyle: UIAlertController.Style.alert)
                        alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                        alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                        self.present(alert, animated: true, completion: nil)
                    }
                }
            }
            
            task.resume()
        }
    }
    
    func isValidNIF(testStr:String) -> Bool {
        let nifRegEx="^[0-9]{8}[TRWAGMYFPDXBNJZSQVHLCKET]{1}$"
        let nifTest = NSPredicate(format:"SELF MATCHES %@", nifRegEx)
        return nifTest.evaluate(with: testStr)
    }
    
    func isValidTelefono(testStr:String) -> Bool{
        let telfRegEx="^[9|6|7][0-9]{8}$"
        let telfTest = NSPredicate(format:"SELF MATCHES %@", telfRegEx)
        return telfTest.evaluate(with:testStr)
    }
    
    func isValidCpostal(testStr:String) -> Bool{
        let cpostalRegEx="^[0-9]{5}$"
        let cpostalTest = NSPredicate(format:"SELF MATCHES %@", cpostalRegEx)
        return cpostalTest.evaluate(with:testStr)
    }
}
