//
//  NewDistribuidorViewController.swift
//  PromoHoreca
//
//  Created by Mireia Izquierdo aymerich on 26/12/18.
//  Copyright © 2018 Mireia Izquierdo aymerich. All rights reserved.
//

import UIKit
import CoreLocation

class NewDistribuidorViewController: UIViewController, UITextFieldDelegate,UIPickerViewDelegate, UIPickerViewDataSource {

    let zona = [["Zona", "Noreste y Baleares", "Levante","Sur","Centro","Noroeste","Norte","Canarias"]]
    var zonaSelected: String = ""
    var fabricanteID: String = ""
    private var indicador: UIActivityIndicatorView = UIActivityIndicatorView()
    @IBOutlet weak var zonaPicker: UIPickerView!
    @IBOutlet weak var dTelefono: UITextField!
    @IBOutlet weak var dCpostal: UITextField!
    @IBOutlet weak var dCiudad: UITextField!
    @IBOutlet weak var dDireccion: UITextField!
    @IBOutlet weak var dNombre: UITextField!
    var chooseCoordinates: CLLocationCoordinate2D?
    let geocoder = CLGeocoder()
    
    override func viewDidLoad() {
        super.viewDidLoad()
        dTelefono.delegate = self
        dCpostal.delegate = self
        dCiudad.delegate = self
        dDireccion.delegate = self
        dNombre.delegate = self
        self.zonaPicker.delegate=self
        self.zonaPicker.dataSource=self
        self.indicador.center=self.view.center
        self.indicador.autoresizingMask = [.flexibleBottomMargin, .flexibleLeftMargin, .flexibleWidth, .flexibleRightMargin, .flexibleTopMargin, .flexibleHeight, .flexibleBottomMargin]
        self.indicador.hidesWhenStopped = true
        self.indicador.style = .gray
        self.view.addSubview(self.indicador)
    }
    
    func numberOfComponents(in pickerView: UIPickerView) -> Int {
        return 1
    }
    
    func pickerView(_ pickerView: UIPickerView, numberOfRowsInComponent component: Int) -> Int {
        
        if pickerView == zonaPicker
        {
            return zona[0].count
        }
        
        return 0
    }
    
    func pickerView(_ pickerView: UIPickerView, titleForRow row: Int, forComponent component: Int) -> String? {
        if pickerView == zonaPicker
        {
            return zona[component][row]
        }
        
        return ""
    }
    
    func pickerView(_ pickerView: UIPickerView, didSelectRow row: Int, inComponent component: Int) {
        
        if pickerView == zonaPicker
        {
            zonaSelected = zona[0][row]
        }
        
        
        // now, every time someone changes the Picker View's value, fruitSelected will be whatever they chose.
    }

    @IBAction func guardarDistri(_ sender: Any) {
        UIApplication.shared.beginIgnoringInteractionEvents()
        indicador.startAnimating()
        
        if dNombre.text == "" ||  dTelefono.text == "" || dDireccion.text == "" || dCiudad.text == "" || dCpostal.text == ""
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "Hay que completar todos los campos del registro.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else if !isValidCpostal(testStr:dCpostal.text!)
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "El formato del campo codigo postal es incorrecto.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else if !isValidTelefono(testStr:dTelefono.text!)
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "El formato del campo teléfono es incorrecto.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else if zonaSelected.isEmpty || zonaSelected == "Zona"
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "Se debe seleccionar una zona.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else
        {
            
            
            
            let address = (dDireccion?.text)! + ", " + (dCiudad?.text)!  + ", " + (dCpostal?.text)!
            var coord:String = ""
            getCoordinates(huidigeLocatie: address) { lat, long, error in
                if error != nil {
                    UIApplication.shared.endIgnoringInteractionEvents()
                    self.indicador.stopAnimating()
                    let alert = UIAlertController(title: "Error", message: "La dirección introducida no es válida.", preferredStyle: UIAlertController.Style.alert)
                    alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                    alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                    self.present(alert, animated: true, completion: nil)
                } else {
                    var urlComponents = URLComponents()
                    urlComponents.scheme = "http"
                    urlComponents.host = "ec2-52-47-86-31.eu-west-3.compute.amazonaws.com"
                    
                    urlComponents.path = "/CreateDistribuidor"
                    let nameItem = URLQueryItem(name: "nombre", value: self.dNombre.text)
                    let telefonoItem = URLQueryItem(name: "telefono", value: self.dTelefono.text)
                    let direccionItem = URLQueryItem(name: "direccion", value: self.dDireccion.text)
                    let ciudadItem = URLQueryItem(name: "ciudad", value: self.dCiudad.text)
                    let cpostalItem = URLQueryItem(name: "cpostal", value: self.dCpostal.text)
                    let zonaItem = URLQueryItem(name: "zona", value: self.zonaSelected)
                    let iditem = URLQueryItem(name:"idusuario", value: self.fabricanteID)
                    coord = "{\(String(describing: lat!)),\(String(describing: long!))}"
                    let coordItem = URLQueryItem(name: "geoposicion", value: coord)
                    
                    urlComponents.queryItems = [iditem, nameItem, telefonoItem, ciudadItem, cpostalItem, direccionItem,zonaItem, coordItem]
                    guard let url = urlComponents.url else { fatalError("Could not create URL from components") }
                    
                    var request = URLRequest(url: url)
                    request.httpMethod = "POST"
                    let config = URLSessionConfiguration.default
                    let session = URLSession(configuration: config)
                    let task = session.dataTask(with: request) { (responseData, response, responseError) in
                        DispatchQueue.main.async {
                            if let error = responseError {
                                print(error)
                                UIApplication.shared.endIgnoringInteractionEvents()
                                self.indicador.stopAnimating()
                                let alert = UIAlertController(title: "Error", message: "No se ha podido registrar el usuario, no se han podido insertar los datos del sistema..", preferredStyle: UIAlertController.Style.alert)
                                alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                                alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                                self.present(alert, animated: true, completion: nil)
                            } else if let jsonData = responseData {
                                // Now we have jsonData, Data representation of the JSON returned to us
                                // from our URLRequest...
                                print(jsonData.description)
                                guard let usuarioreg = try? JSONDecoder().decode(UsuarioReg.self, from: jsonData) else {
                                    UIApplication.shared.endIgnoringInteractionEvents()
                                    self.indicador.stopAnimating()
                                    let alert = UIAlertController(title: "Error", message: "No se ha podido crear el distribuidor, no se han podido insertar los datos del sistema.", preferredStyle: UIAlertController.Style.alert)
                                    alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                                    alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                                    self.present(alert, animated: true, completion: nil)
                                    return
                                }
                                if (usuarioreg.status==200){
                                    UIApplication.shared.endIgnoringInteractionEvents()
                                    self.indicador.stopAnimating()
                                    let alert = UIAlertController(title: "Distribuidor creado", message: "El distribuidor se ha creado con exito.", preferredStyle: UIAlertController.Style.alert)
                                    let okAction = UIAlertAction(title: "OK", style: UIAlertAction.Style.default) {
                                        UIAlertAction in
                                        self.performSegue(withIdentifier: "backtoDistri", sender: nil)
                                    }
                                    alert.addAction(okAction)
                                    alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                                    self.present(alert, animated: true, completion: nil)
                                    
                                    
                                }
                                else{
                                    UIApplication.shared.endIgnoringInteractionEvents()
                                    self.indicador.stopAnimating()
                                    let alert = UIAlertController(title: "Error", message: "No se ha podido crear el distribuidor, no se han podido insertar los datos del sistema.", preferredStyle: UIAlertController.Style.alert)
                                    alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                                    alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                                    self.present(alert, animated: true, completion: nil)
                                }
                                
                            } else {
                                let error = NSError(domain: "", code: 0, userInfo: [NSLocalizedDescriptionKey : "Data was not retrieved from request"]) as Error
                                print(error)
                                UIApplication.shared.endIgnoringInteractionEvents()
                                self.indicador.stopAnimating()
                                let alert = UIAlertController(title: "Error", message: "No se ha podido crear el distribuidor, no se han podido insertar los datos del sistema.", preferredStyle: UIAlertController.Style.alert)
                                alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                                alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                                self.present(alert, animated: true, completion: nil)
                            }
                        }
                    }
                    
                    task.resume()
                }
                }
            }
            
    }
    
    func textFieldShouldReturn(_ textField: UITextField) -> Bool {
        textField.resignFirstResponder()
        return true
    }
    
    func isValidTelefono(testStr:String) -> Bool{
        let telfRegEx="^[9|6|7][0-9]{8}$"
        let telfTest = NSPredicate(format:"SELF MATCHES %@", telfRegEx)
        return telfTest.evaluate(with:testStr)
    }
    
    func isValidCpostal(testStr:String) -> Bool{
        let cpostalRegEx="^[0-9]{5}$"
        let cpostalTest = NSPredicate(format:"SELF MATCHES %@", cpostalRegEx)
        return cpostalTest.evaluate(with:testStr)
    }
    
    func getCoordinates(huidigeLocatie: String, completionHandler: @escaping ( CLLocationDegrees?,  CLLocationDegrees?,  NSError?) -> ()) -> Void {

        let geocoderHuidigeLocatie = CLGeocoder()
        
        geocoderHuidigeLocatie.geocodeAddressString(huidigeLocatie) { (placemarks, error) in
            
            if error != nil {
                
                completionHandler(nil, nil, error as NSError?)
                
            } else if (placemarks?.count)! > 0 {
                
                let placemark = placemarks?[0]
                let location = placemark?.location
                
                let lat = location?.coordinate.latitude
                let long = location?.coordinate.longitude
                
                completionHandler(lat, long, nil)
            }
        }
    }
    
    

}
