//
//  RegEstabTableViewController.swift
//  PromoHoreca
//
//  Created by Mireia Izquierdo aymerich on 26/11/18.
//  Copyright © 2018 Mireia Izquierdo aymerich. All rights reserved.
//

import UIKit

class RegEstabTableViewController: UITableViewController,UIPickerViewDelegate, UIPickerViewDataSource, UITextFieldDelegate {
    
    @IBOutlet weak var eNombre: UITextField!
    @IBOutlet weak var eNIF: UITextField!
    @IBOutlet weak var eTelefono: UITextField!
    @IBOutlet weak var eDireccion: UITextField!
    @IBOutlet weak var eCPostal: UITextField!
    @IBOutlet weak var eCiudad: UITextField!
    @IBOutlet weak var eEmail: UITextField!
    @IBOutlet weak var ePassword: UITextField!
    @IBOutlet weak var eVPassword: UITextField!
    @IBOutlet weak var zonaPicker: UIPickerView!
    @IBOutlet weak var tipoPicker: UIPickerView!
    @IBOutlet weak var eSAlimentacion: UISwitch!
    @IBOutlet weak var eSLact: UISwitch!
    @IBOutlet weak var esBAlc: UISwitch!
    @IBOutlet weak var eSBSAlc: UISwitch!
    @IBOutlet weak var eSCongelados: UISwitch!
    @IBOutlet weak var eSSnacks: UISwitch!
    let zona = [["Zona", "Noreste y Baleares", "Levante","Sur","Centro","Noroeste","Norte","Canarias"]]
    let tipo = [["Tipo de establecimiento", "Restaurante", "Cafeteria", "Hotel", "Gasolinera", "Alimentación tradicional", "Quiosco","Ocio nocturno", "Tenda de Snacks", "Restauración social"]]
    var zonaSelected: String = ""
    var tipoSelected: String = ""
    private var indicador: UIActivityIndicatorView = UIActivityIndicatorView()
    
    
    override func viewDidLoad() {
        super.viewDidLoad()
        self.zonaPicker.delegate=self
        self.zonaPicker.dataSource=self
        self.tipoPicker.delegate=self
        self.tipoPicker.dataSource=self
        self.eNombre.delegate=self
        self.eNIF.delegate=self
        self.eTelefono.delegate=self
        self.eDireccion.delegate=self
        self.eCPostal.delegate=self
        self.eEmail.delegate=self
        self.ePassword.delegate=self
        self.eVPassword.delegate=self
        
        self.indicador.center=self.view.center
        self.indicador.autoresizingMask = [.flexibleBottomMargin, .flexibleLeftMargin, .flexibleWidth, .flexibleRightMargin, .flexibleTopMargin, .flexibleHeight, .flexibleBottomMargin]
        self.indicador.hidesWhenStopped = true
        self.indicador.style = .gray
        self.view.addSubview(self.indicador)

        // Uncomment the following line to preserve selection between presentations
        // self.clearsSelectionOnViewWillAppear = false

        // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
        // self.navigationItem.rightBarButtonItem = self.editButtonItem
    }

    // MARK: - Table view data source

    
    func numberOfComponents(in pickerView: UIPickerView) -> Int {
        return 1
    }
    
    func pickerView(_ pickerView: UIPickerView, numberOfRowsInComponent component: Int) -> Int {
        
        if pickerView == zonaPicker
        {
            return zona[0].count
        }
        else if pickerView == tipoPicker
        {
            return tipo[0].count
        }
        return 0
    }
    
    func pickerView(_ pickerView: UIPickerView, titleForRow row: Int, forComponent component: Int) -> String? {
        if pickerView == zonaPicker
        {
            return zona[component][row]
        }
        else if pickerView == tipoPicker
        {
            return tipo[component][row]
        }
        return ""
    }
    
    func pickerView(_ pickerView: UIPickerView, didSelectRow row: Int, inComponent component: Int) {
        
        if pickerView == zonaPicker
        {
            zonaSelected = zona[0][row]
        }
        else if pickerView == tipoPicker
        {
            tipoSelected = tipo[0][row]
        }
        
        // now, every time someone changes the Picker View's value, fruitSelected will be whatever they chose.
    }
    
    override func viewDidLayoutSubviews() {
        super.viewDidLayoutSubviews()
    }
    
    @IBAction func registrarAction(_ sender: Any) {
        UIApplication.shared.beginIgnoringInteractionEvents()
        indicador.startAnimating()
        
        if eNombre.text == "" || eNIF.text == "" || eTelefono.text == "" || eDireccion.text == "" || eCiudad.text == "" || eCPostal.text == "" || eEmail.text == "" || eVPassword.text == "" || ePassword.text == ""
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "Hay que completar todos los campos del registro.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else if !isValidEmail(testStr: eEmail.text!)
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "El correo electrónico intoducido no es válido.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else if ePassword.text != eVPassword.text
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "Las contraseñas no coinciden.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else if !isValidPassword(testStr:ePassword.text!)
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "La contraseña debe ser de al menos 8 caracteres y contener al menos una mayúscula, una mínuscula y un número.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else if !isValidNIF(testStr:eNIF.text!)
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "El formato del campo NIF es incorrecto.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else if !isValidCpostal(testStr:eCPostal.text!)
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "El formato del campo codigo postal es incorrecto.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else if !isValidTelefono(testStr:eTelefono.text!)
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "El formato del campo teléfono es incorrecto.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else if eSAlimentacion.isOn==false && eSLact.isOn==false && esBAlc.isOn==false && eSBSAlc.isOn==false && eSCongelados.isOn==false && eSSnacks.isOn==false
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "Se debe seleccionar almenos un tipo de producto.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else if zonaSelected.isEmpty || zonaSelected == "Zona"
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "Se debe seleccionar una zona.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else if tipoSelected.isEmpty || tipoSelected == "Zona"
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "Se debe seleccionar un tipo de establecimiento.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else
        {
            
            var urlComponents = URLComponents()
            urlComponents.scheme = "http"
            urlComponents.host = "ec2-52-47-86-31.eu-west-3.compute.amazonaws.com"
            
            urlComponents.path = "/ExistsUser"
            let emailItem = URLQueryItem(name: "email", value: eEmail.text)
            let nameItem = URLQueryItem(name: "nombre", value: eNombre.text)
            let tipoUItem = URLQueryItem(name: "tipousuario", value: "E")
            let nifItem = URLQueryItem(name: "nif", value: eNIF.text)
            let telefonoItem = URLQueryItem(name: "telefono", value: eTelefono.text)
            let direccionItem = URLQueryItem(name: "direccion", value: eDireccion.text)
            let ciudadItem = URLQueryItem(name: "ciudad", value: eCiudad.text)
            let cpostalItem = URLQueryItem(name: "cpostal", value: eCPostal.text)
            //let emailItem = URLQueryItem(name: "email", value: eEmail.text)
            let passwordItem = URLQueryItem(name: "password", value: ePassword.text)
            
            urlComponents.queryItems = [emailItem]
            guard let urle = urlComponents.url else { fatalError("Could not create URL from components") }
            var requeste = URLRequest(url: urle)
            requeste.httpMethod = "GET"
            let confige = URLSessionConfiguration.default
            let sessione = URLSession(configuration: confige)
            let taske = sessione.dataTask(with: requeste) { (responseData, response, responseError) in
                DispatchQueue.main.async {
                    if let error = responseError {
                        print(error)
                        UIApplication.shared.endIgnoringInteractionEvents()
                        self.indicador.stopAnimating()
                        let alert = UIAlertController(title: "Error", message: "No se ha podido registrar el usuario, no se han podido insertar los datos del sistema..", preferredStyle: UIAlertController.Style.alert)
                        alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                        alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                        self.present(alert, animated: true, completion: nil)
                    } else if let jsonData = responseData {
                        print(jsonData.description)
                        guard let peticionstatus = try? JSONDecoder().decode(PeticionStatus.self, from: jsonData) else {
                            UIApplication.shared.endIgnoringInteractionEvents()
                            self.indicador.stopAnimating()
                            let alert = UIAlertController(title: "Error", message: "No se ha podido consultar si el usuario existe en el sistema.", preferredStyle: UIAlertController.Style.alert)
                            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                            self.present(alert, animated: true, completion: nil)
                            return
                        }
                        if peticionstatus.status==100{
                            UIApplication.shared.endIgnoringInteractionEvents()
                            self.indicador.stopAnimating()
                            let alert = UIAlertController(title: "Error", message: "El usuario ya existe en el sistema", preferredStyle: UIAlertController.Style.alert)
                            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                            self.present(alert, animated: true, completion: nil)
                            return
                        }
                        else{
                            urlComponents.path = "/CreateUser"
                            var preferencias = ""
                            if (self.eSAlimentacion.isOn && preferencias.isEmpty)
                            {
                                preferencias = "Alimentación"
                                
                            }else if (self.eSAlimentacion.isOn && !preferencias.isEmpty)
                            {
                                preferencias = preferencias + "," +  "Alimentación"
                            }
                            
                            if (self.esBAlc.isOn && preferencias.isEmpty)
                            {
                                preferencias = "Bebidas con alcohol"
                                
                            }else if (self.esBAlc.isOn && !preferencias.isEmpty)
                            {
                                preferencias = preferencias + "," +  "Bebidas con alcohol"
                            }
                            
                            if (self.eSBSAlc.isOn && preferencias.isEmpty)
                            {
                                preferencias = "Bebidas sin alcohol"
                                
                            }else if (self.eSBSAlc.isOn && !preferencias.isEmpty)
                            {
                                preferencias = preferencias + "," +  "Bebidas sin alcohol"
                            }
                            
                            if (self.eSLact.isOn && preferencias.isEmpty)
                            {
                                preferencias = "Lácteos"
                                
                            }else if (self.eSLact.isOn && !preferencias.isEmpty)
                            {
                                preferencias = preferencias + "," +  "Lácteos"
                            }
                            
                            if (self.eSSnacks.isOn && preferencias.isEmpty)
                            {
                                preferencias = "Snacks"
                                
                            }else if (self.eSSnacks.isOn && !preferencias.isEmpty)
                            {
                                preferencias = preferencias + "," +  "Snacks"
                            }
                            
                            if (self.eSCongelados.isOn && preferencias.isEmpty)
                            {
                                preferencias = "Congelados"
                                
                            }else if (self.eSCongelados.isOn && !preferencias.isEmpty)
                            {
                                preferencias = preferencias + "," +  "Congelados"
                            }
                            
                            preferencias = "{" + preferencias + "}"
                            
                            let preferenciasItem = URLQueryItem(name: "preferencias", value: preferencias)
                            let tipoestabItem = URLQueryItem(name: "tipoestab", value: self.tipoSelected)
                            let zonaItem = URLQueryItem(name: "zona", value: self.zonaSelected)
                            
                            
                            urlComponents.queryItems = [nameItem, tipoUItem, nifItem, telefonoItem, ciudadItem, cpostalItem, direccionItem, tipoestabItem, zonaItem,emailItem,passwordItem,preferenciasItem]
                            guard let url = urlComponents.url else { fatalError("Could not create URL from components") }
                            
                            var request = URLRequest(url: url)
                            request.httpMethod = "POST"
                            let config = URLSessionConfiguration.default
                            let session = URLSession(configuration: config)
                            let task = session.dataTask(with: request) { (responseData, response, responseError) in
                                DispatchQueue.main.async {
                                    if let error = responseError {
                                        print(error)
                                        UIApplication.shared.endIgnoringInteractionEvents()
                                        self.indicador.stopAnimating()
                                        let alert = UIAlertController(title: "Error", message: "No se ha podido registrar el usuario, no se han podido insertar los datos del sistema..", preferredStyle: UIAlertController.Style.alert)
                                        alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                                        alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                                        self.present(alert, animated: true, completion: nil)
                                    } else if let jsonData = responseData {
                                        // Now we have jsonData, Data representation of the JSON returned to us
                                        // from our URLRequest...
                                        print(jsonData.description)
                                        guard let usuarioreg = try? JSONDecoder().decode(UsuarioReg.self, from: jsonData) else {
                                            UIApplication.shared.endIgnoringInteractionEvents()
                                            self.indicador.stopAnimating()
                                            let alert = UIAlertController(title: "Error", message: "No se ha podido registrar el usuario, no se han podido insertar los datos del sistema.", preferredStyle: UIAlertController.Style.alert)
                                            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                                            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                                            self.present(alert, animated: true, completion: nil)
                                            return
                                        }
                                        if (usuarioreg.status==200){
                                            UIApplication.shared.endIgnoringInteractionEvents()
                                            self.indicador.stopAnimating()
                                            let alert = UIAlertController(title: "Usuario Registrado", message: "El usuario se ha registrado con exito.", preferredStyle: UIAlertController.Style.alert)
                                            let okAction = UIAlertAction(title: "OK", style: UIAlertAction.Style.default) {
                                                UIAlertAction in
                                                self.performSegue(withIdentifier: "backToLogin", sender: nil)
                                            }
                                            alert.addAction(okAction)
                                            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                                            self.present(alert, animated: true, completion: nil)
                                            
                                            
                                        }
                                        else{
                                            UIApplication.shared.endIgnoringInteractionEvents()
                                            self.indicador.stopAnimating()
                                            let alert = UIAlertController(title: "Error", message: "No se ha podido registrar el usuario, no se han podido insertar los datos del sistema.", preferredStyle: UIAlertController.Style.alert)
                                            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                                            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                                            self.present(alert, animated: true, completion: nil)
                                        }
                                        
                                    } else {
                                        let error = NSError(domain: "", code: 0, userInfo: [NSLocalizedDescriptionKey : "Data was not retrieved from request"]) as Error
                                        print(error)
                                        UIApplication.shared.endIgnoringInteractionEvents()
                                        self.indicador.stopAnimating()
                                        let alert = UIAlertController(title: "Error", message: "No se ha podido registrar el usuario, no se han podido insertar los datos del sistema.", preferredStyle: UIAlertController.Style.alert)
                                        alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                                        alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                                        self.present(alert, animated: true, completion: nil)
                                    }
                                }
                            }
                            
                            task.resume()
                        }

                        
                    }
                }
            }
            taske.resume()
            
            
        }
    }
    
    func isValidEmail(testStr:String) -> Bool {
        let emailRegEx = "[A-Z0-9a-z._%+-]+@[A-Za-z0-9.-]+\\.[A-Za-z]{2,}"
        
        let emailTest = NSPredicate(format:"SELF MATCHES %@", emailRegEx)
        return emailTest.evaluate(with: testStr)
    }
    
    func isValidPassword(testStr:String) -> Bool {
        let passRegEx = "^(?=.*[a-z])(?=.*[A-Z])(?=.*\\d)[a-zA-Z\\d]{8,}$"
        let passTest = NSPredicate(format:"SELF MATCHES %@", passRegEx)
        return passTest.evaluate(with: testStr)
    }
    
    func isValidNIF(testStr:String) -> Bool {
        let nifRegEx="^[0-9]{8}[TRWAGMYFPDXBNJZSQVHLCKET]{1}$"
        let nifTest = NSPredicate(format:"SELF MATCHES %@", nifRegEx)
        return nifTest.evaluate(with: testStr)
    }
    
    func isValidTelefono(testStr:String) -> Bool{
        let telfRegEx="^[9|6|7][0-9]{8}$"
        let telfTest = NSPredicate(format:"SELF MATCHES %@", telfRegEx)
        return telfTest.evaluate(with:testStr)
    }
    
    func isValidCpostal(testStr:String) -> Bool{
        let cpostalRegEx="^[0-9]{5}$"
        let cpostalTest = NSPredicate(format:"SELF MATCHES %@", cpostalRegEx)
        return cpostalTest.evaluate(with:testStr)
    }
}
