//
//  RegFabTableViewController.swift
//  PromoHoreca
//
//  Created by Mireia Izquierdo aymerich on 29/11/18.
//  Copyright © 2018 Mireia Izquierdo aymerich. All rights reserved.
//

import UIKit

class RegFabTableViewController: UITableViewController,UIPickerViewDelegate, UITextFieldDelegate {
    @IBOutlet weak var fNombre: UITextField!
    @IBOutlet weak var fVPassword: UITextField!
    @IBOutlet weak var fPassword: UITextField!
    @IBOutlet weak var fEmail: UITextField!
    @IBOutlet weak var fCpostal: UITextField!
    @IBOutlet weak var fCiudad: UITextField!
    @IBOutlet weak var fTelefono: UITextField!
    @IBOutlet weak var fDireccion: UITextField!
    @IBOutlet weak var fNif: UITextField!
    
    @IBOutlet weak var fSCongelados: UISwitch!
    @IBOutlet weak var fSSnacks: UISwitch!
    @IBOutlet weak var fSLact: UISwitch!
    @IBOutlet weak var fSBebAlc: UISwitch!
    @IBOutlet weak var fSBebSAlc: UISwitch!
    @IBOutlet weak var fSAlim: UISwitch!
    
    private var indicador: UIActivityIndicatorView = UIActivityIndicatorView()

    override func viewDidLoad() {
        super.viewDidLoad()

        self.fNombre.delegate=self
        self.fVPassword.delegate=self
        self.fPassword.delegate=self
        self.fEmail.delegate=self
        self.fCpostal.delegate=self
        self.fCiudad.delegate=self
        self.fTelefono.delegate=self
        self.fDireccion.delegate=self
        self.fNif.delegate=self
        
        self.indicador.center=self.view.center
        self.indicador.autoresizingMask = [.flexibleBottomMargin, .flexibleLeftMargin, .flexibleWidth, .flexibleRightMargin, .flexibleTopMargin, .flexibleHeight, .flexibleBottomMargin]
        self.indicador.hidesWhenStopped = true
        self.indicador.style = .gray
        self.view.addSubview(self.indicador)
        // Uncomment the following line to preserve selection between presentations
        // self.clearsSelectionOnViewWillAppear = false

        // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
        // self.navigationItem.rightBarButtonItem = self.editButtonItem
    }

    // MARK: - Table view data source

    override func viewDidLayoutSubviews() {
        super.viewDidLayoutSubviews()
    }
    
    
    @IBAction func registroAction(_ sender: Any) {
        UIApplication.shared.beginIgnoringInteractionEvents()
        indicador.startAnimating()
        
        if fNombre.text == "" || fNif.text == "" || fTelefono.text == "" || fDireccion.text == "" || fCiudad.text == "" || fCpostal.text == "" || fEmail.text == "" || fVPassword.text == "" || fPassword.text == ""
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "Hay que completar todos los campos del registro.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else if !isValidEmail(testStr: fEmail.text!)
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "El correo electrónico intoducido no es válido.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else if fPassword.text != fVPassword.text
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "Las contraseñas no coinciden.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else if !isValidPassword(testStr:fPassword.text!)
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "La contraseña debe ser de al menos 8 caracteres y contener al menos una mayúscula, una mínuscula y un número.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else if !isValidNIF(testStr:fNif.text!)
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "El formato del campo NIF es incorrecto.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else if !isValidCpostal(testStr:fCpostal.text!)
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "El formato del campo codigo postal es incorrecto.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else if !isValidTelefono(testStr:fTelefono.text!)
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "El formato del campo teléfono es incorrecto.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else if fSAlim.isOn==false && fSLact.isOn==false && fSBebAlc.isOn==false && fSBebSAlc.isOn==false && fSCongelados.isOn==false && fSSnacks.isOn==false
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "Se debe seleccionar almenos un tipo de producto.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else
        {
            
            var urlComponents = URLComponents()
            urlComponents.scheme = "http"
            urlComponents.host = "ec2-52-47-86-31.eu-west-3.compute.amazonaws.com"
            
            urlComponents.path = "/ExistsUser"
            let emailItem = URLQueryItem(name: "email", value: fEmail.text)
            let nameItem = URLQueryItem(name: "nombre", value: fNombre.text)
            let tipoUItem = URLQueryItem(name: "tipousuario", value: "F")
            let nifItem = URLQueryItem(name: "nif", value: fNif.text)
            let telefonoItem = URLQueryItem(name: "telefono", value: fTelefono.text)
            let direccionItem = URLQueryItem(name: "direccion", value: fDireccion.text)
            let ciudadItem = URLQueryItem(name: "ciudad", value: fCiudad.text)
            let cpostalItem = URLQueryItem(name: "cpostal", value: fCpostal.text)
            //let emailItem = URLQueryItem(name: "email", value: eEmail.text)
            let passwordItem = URLQueryItem(name: "password", value: fPassword.text)
            
            urlComponents.queryItems = [emailItem]
            guard let urle = urlComponents.url else { fatalError("Could not create URL from components") }
            var requeste = URLRequest(url: urle)
            requeste.httpMethod = "GET"
            let confige = URLSessionConfiguration.default
            let sessione = URLSession(configuration: confige)
            let taske = sessione.dataTask(with: requeste) { (responseData, response, responseError) in
                DispatchQueue.main.async {
                    if let error = responseError {
                        print(error)
                        UIApplication.shared.endIgnoringInteractionEvents()
                        self.indicador.stopAnimating()
                        let alert = UIAlertController(title: "Error", message: "No se ha podido registrar el usuario, no se han podido insertar los datos del sistema..", preferredStyle: UIAlertController.Style.alert)
                        alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                        alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                        self.present(alert, animated: true, completion: nil)
                    } else if let jsonData = responseData {
                        print(jsonData.description)
                        guard let peticionstatus = try? JSONDecoder().decode(PeticionStatus.self, from: jsonData) else {
                            UIApplication.shared.endIgnoringInteractionEvents()
                            self.indicador.stopAnimating()
                            let alert = UIAlertController(title: "Error", message: "No se ha podido consultar si el usuario existe en el sistema.", preferredStyle: UIAlertController.Style.alert)
                            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                            self.present(alert, animated: true, completion: nil)
                            return
                        }
                        if peticionstatus.status==100{
                            UIApplication.shared.endIgnoringInteractionEvents()
                            self.indicador.stopAnimating()
                            let alert = UIAlertController(title: "Error", message: "El usuario ya existe en el sistema", preferredStyle: UIAlertController.Style.alert)
                            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                            self.present(alert, animated: true, completion: nil)
                            return
                        }
                        else{
                            urlComponents.path = "/CreateUser"
                            var preferencias = ""
                            if (self.fSAlim.isOn && preferencias.isEmpty)
                            {
                                preferencias = "Alimentación"
                                
                            }else if (self.fSAlim.isOn && !preferencias.isEmpty)
                            {
                                preferencias = preferencias + "," +  "Alimentación"
                            }
                            
                            if (self.fSBebAlc.isOn && preferencias.isEmpty)
                            {
                                preferencias = "Bebidas con alcohol"
                                
                            }else if (self.fSBebAlc.isOn && !preferencias.isEmpty)
                            {
                                preferencias = preferencias + "," +  "Bebidas con alcohol"
                            }
                            
                            if (self.fSBebSAlc.isOn && preferencias.isEmpty)
                            {
                                preferencias = "Bebidas sin alcohol"
                                
                            }else if (self.fSBebSAlc.isOn && !preferencias.isEmpty)
                            {
                                preferencias = preferencias + "," +  "Bebidas sin alcohol"
                            }
                            
                            if (self.fSLact.isOn && preferencias.isEmpty)
                            {
                                preferencias = "Lácteos"
                                
                            }else if (self.fSLact.isOn && !preferencias.isEmpty)
                            {
                                preferencias = preferencias + "," +  "Lácteos"
                            }
                            
                            if (self.fSSnacks.isOn && preferencias.isEmpty)
                            {
                                preferencias = "Snacks"
                                
                            }else if (self.fSSnacks.isOn && !preferencias.isEmpty)
                            {
                                preferencias = preferencias + "," +  "Snacks"
                            }
                            
                            if (self.fSCongelados.isOn && preferencias.isEmpty)
                            {
                                preferencias = "Congelados"
                                
                            }else if (self.fSCongelados.isOn && !preferencias.isEmpty)
                            {
                                preferencias = preferencias + "," +  "Congelados"
                            }
                            
                            preferencias = "{" + preferencias + "}"
                            
                            let preferenciasItem = URLQueryItem(name: "preferencias", value: preferencias)
                            let tipoestabItem = URLQueryItem(name: "tipoestab", value: "")
                            let zonaItem = URLQueryItem(name: "zona", value: "")
                            
                            
                            urlComponents.queryItems = [nameItem, tipoUItem, nifItem, telefonoItem, ciudadItem, cpostalItem, direccionItem, tipoestabItem, zonaItem,emailItem,passwordItem,preferenciasItem]
                            guard let url = urlComponents.url else { fatalError("Could not create URL from components") }
                            
                            var request = URLRequest(url: url)
                            request.httpMethod = "POST"
                            let config = URLSessionConfiguration.default
                            let session = URLSession(configuration: config)
                            let task = session.dataTask(with: request) { (responseData, response, responseError) in
                                DispatchQueue.main.async {
                                    if let error = responseError {
                                        print(error)
                                        UIApplication.shared.endIgnoringInteractionEvents()
                                        self.indicador.stopAnimating()
                                        let alert = UIAlertController(title: "Error", message: "No se ha podido registrar el usuario, no se han podido insertar los datos del sistema..", preferredStyle: UIAlertController.Style.alert)
                                        alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                                        alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                                        self.present(alert, animated: true, completion: nil)
                                    } else if let jsonData = responseData {
                                        // Now we have jsonData, Data representation of the JSON returned to us
                                        // from our URLRequest...
                                        print(jsonData.description)
                                        guard let usuarioreg = try? JSONDecoder().decode(UsuarioReg.self, from: jsonData) else {
                                            UIApplication.shared.endIgnoringInteractionEvents()
                                            self.indicador.stopAnimating()
                                            let alert = UIAlertController(title: "Error", message: "No se ha podido registrar el usuario, no se han podido insertar los datos del sistema.", preferredStyle: UIAlertController.Style.alert)
                                            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                                            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                                            self.present(alert, animated: true, completion: nil)
                                            return
                                        }
                                        if (usuarioreg.status==200){
                                            UIApplication.shared.endIgnoringInteractionEvents()
                                            self.indicador.stopAnimating()
                                            let alert = UIAlertController(title: "Usuario Registrado", message: "El usuario se ha registrado con exito.", preferredStyle: UIAlertController.Style.alert)
                                            let okAction = UIAlertAction(title: "OK", style: UIAlertAction.Style.default) {
                                                UIAlertAction in
                                                self.performSegue(withIdentifier: "backToLogin", sender: nil)
                                            }
                                            alert.addAction(okAction)
                                            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                                            self.present(alert, animated: true, completion: nil)
                                            
                                            
                                        }
                                        else{
                                            UIApplication.shared.endIgnoringInteractionEvents()
                                            self.indicador.stopAnimating()
                                            let alert = UIAlertController(title: "Error", message: "No se ha podido registrar el usuario, no se han podido insertar los datos del sistema.", preferredStyle: UIAlertController.Style.alert)
                                            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                                            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                                            self.present(alert, animated: true, completion: nil)
                                        }
                                        
                                    } else {
                                        let error = NSError(domain: "", code: 0, userInfo: [NSLocalizedDescriptionKey : "Data was not retrieved from request"]) as Error
                                        print(error)
                                        UIApplication.shared.endIgnoringInteractionEvents()
                                        self.indicador.stopAnimating()
                                        let alert = UIAlertController(title: "Error", message: "No se ha podido registrar el usuario, no se han podido insertar los datos del sistema.", preferredStyle: UIAlertController.Style.alert)
                                        alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                                        alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                                        self.present(alert, animated: true, completion: nil)
                                    }
                                }
                            }
                            
                            task.resume()
                        }
                        
                        
                    }
                }
            }
            taske.resume()
            
            
        }
    }
    
    func isValidEmail(testStr:String) -> Bool {
        let emailRegEx = "[A-Z0-9a-z._%+-]+@[A-Za-z0-9.-]+\\.[A-Za-z]{2,}"
        
        let emailTest = NSPredicate(format:"SELF MATCHES %@", emailRegEx)
        return emailTest.evaluate(with: testStr)
    }
    
    func isValidPassword(testStr:String) -> Bool {
        let passRegEx = "^(?=.*[a-z])(?=.*[A-Z])(?=.*\\d)[a-zA-Z\\d]{8,}$"
        let passTest = NSPredicate(format:"SELF MATCHES %@", passRegEx)
        return passTest.evaluate(with: testStr)
    }
    
    func isValidNIF(testStr:String) -> Bool {
        let nifRegEx="^[0-9]{8}[TRWAGMYFPDXBNJZSQVHLCKET]{1}$"
        let nifTest = NSPredicate(format:"SELF MATCHES %@", nifRegEx)
        return nifTest.evaluate(with: testStr)
    }
    
    func isValidTelefono(testStr:String) -> Bool{
        let telfRegEx="^[9|6|7][0-9]{8}$"
        let telfTest = NSPredicate(format:"SELF MATCHES %@", telfRegEx)
        return telfTest.evaluate(with:testStr)
    }
    
    func isValidCpostal(testStr:String) -> Bool{
        let cpostalRegEx="^[0-9]{5}$"
        let cpostalTest = NSPredicate(format:"SELF MATCHES %@", cpostalRegEx)
        return cpostalTest.evaluate(with:testStr)
    }
    

}
