//
//  RegTableViewController.swift
//  PromoHoreca
//
//  Created by Mireia Izquierdo aymerich on 25/11/18.
//  Copyright © 2018 Mireia Izquierdo aymerich. All rights reserved.
//

import UIKit

class RegTableViewController: UITableViewController {
    @IBOutlet weak var estabButton: UIButton!
    @IBOutlet weak var regLabel: UILabel!
    
    override func viewDidLoad() {
        super.viewDidLoad()

        let tapGesture = UITapGestureRecognizer(target: self, action:#selector(UIViewController.dismissKeyboard))
        tableView.addGestureRecognizer(tapGesture)
        // Uncomment the following line to preserve selection between presentations
        // self.clearsSelectionOnViewWillAppear = false

        // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
        // self.navigationItem.rightBarButtonItem = self.editButtonItem
    }

    // MARK: - Table view data source

   /* override func numberOfSections(in tableView: UITableView) -> Int {
        // #warning Incomplete implementation, return the number of sections
        return 0
    }

    override func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        // #warning Incomplete implementation, return the number of rows
        return 0
    }*/
    
    
    func scrollViewWillBeginDragging(scrollView: UIScrollView) {
        dismissKeyboard()
    }
    
    override func dismissKeyboard(){
        self.view.endEditing(true)
    }
    
    func tableView(tableView: UITableView, didSelectRowAtIndexPath indexPath: NSIndexPath){
        dismissKeyboard()
    }
    
    override func viewDidLayoutSubviews() {
        super.viewDidLayoutSubviews()
        let contentSize = self.tableView.contentSize
        self.centerTableView()
        self.tableView.rowHeight = UITableView.automaticDimension
        self.regLabel.numberOfLines=0
        self.regLabel.preferredMaxLayoutWidth=contentSize.width/2+150
        self.regLabel.lineBreakMode=NSLineBreakMode.byWordWrapping
        estabButton.titleLabel?.numberOfLines=0
        estabButton.titleLabel?.preferredMaxLayoutWidth=contentSize.width/2+150
        estabButton.titleLabel?.adjustsFontSizeToFitWidth=true
        estabButton.titleLabel?.translatesAutoresizingMaskIntoConstraints = false;
        estabButton.titleLabel?.lineBreakMode = .byWordWrapping
        
        /*let label = self.estabButton?.titleLabel
        label?.minimumScaleFactor = 0.01
        label?.adjustsFontSizeToFitWidth = true
        label?.lineBreakMode = .byWordWrapping*/

    }
    
    func centerTableView() {
        
        let contentSize = self.tableView.contentSize
        let boundsSize = self.tableView.bounds.size
        
        if contentSize.height < boundsSize.height {
            
            let yOffset = floor(boundsSize.height - contentSize.height) / 2
            
            tableView.contentOffset = CGPoint(x:0, y:-yOffset)
        }
    }
    
    func textFieldShouldReturn(_ textField: UITextField) -> Bool {
        textField.resignFirstResponder()
        return true
    }


    /*
    override func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "reuseIdentifier", for: indexPath)

        // Configure the cell...

        return cell
    }
    */

    /*
    // Override to support conditional editing of the table view.
    override func tableView(_ tableView: UITableView, canEditRowAt indexPath: IndexPath) -> Bool {
        // Return false if you do not want the specified item to be editable.
        return true
    }
    */

    /*
    // Override to support editing the table view.
    override func tableView(_ tableView: UITableView, commit editingStyle: UITableViewCellEditingStyle, forRowAt indexPath: IndexPath) {
        if editingStyle == .delete {
            // Delete the row from the data source
            tableView.deleteRows(at: [indexPath], with: .fade)
        } else if editingStyle == .insert {
            // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
        }    
    }
    */

    /*
    // Override to support rearranging the table view.
    override func tableView(_ tableView: UITableView, moveRowAt fromIndexPath: IndexPath, to: IndexPath) {

    }
    */

    /*
    // Override to support conditional rearranging of the table view.
    override func tableView(_ tableView: UITableView, canMoveRowAt indexPath: IndexPath) -> Bool {
        // Return false if you do not want the item to be re-orderable.
        return true
    }
    */

    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        // Get the new view controller using segue.destination.
        // Pass the selected object to the new view controller.
    }
    */

}
