//
//  addPromoTableViewController.swift
//  PromoHoreca
//
//  Created by Mireia Izquierdo aymerich on 3/12/18.
//  Copyright © 2018 Mireia Izquierdo aymerich. All rights reserved.
//

import Foundation
import UIKit
import AWSCore
import AWSS3
import Photos
import AVFoundation
import AVKit

class DataSource: NSObject, UITableViewDataSource, UITableViewDelegate {
    
    var items : [String] = ["Noreste y Baleares", "Levante","Sur","Centro","Noroeste","Norte","Canarias"]
    
    func numberOfSectionsInTableView(tableView: UITableView) -> Int {
        
        return 1;
    }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {

            return items.count

    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        
        let cell = tableView.dequeueReusableCell(withIdentifier: "CheckableTableViewCell", for: indexPath) as! CheckableTableViewCell

             cell.dinlabel!.text = items[indexPath.row]

       
        return cell
    }
    
    
    
    
}

class DataSourcetipo: NSObject, UITableViewDataSource, UITableViewDelegate {
    
    
    var itemst : [String] = ["Restaurante", "Cafeteria", "Hotel", "Gasolinera", "Alimentación tradicional", "Quiosco","Ocio nocturno", "Tenda de Snacks", "Restauración social"]
    
    func numberOfSectionsInTableView(tableView: UITableView) -> Int {
        
        return 1;
    }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        
        return itemst.count
        
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        
        let cell = tableView.dequeueReusableCell(withIdentifier: "CheckableTableViewCell", for: indexPath) as! CheckableTableViewCell
        
        cell.tipolabel!.text = itemst[indexPath.row]
        
        
        return cell
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return UITableView.automaticDimension
    }
    
    
    
    
}

class addPromoTableViewController: UITableViewController, UIImagePickerControllerDelegate, UINavigationControllerDelegate, UIPickerViewDelegate, UIPickerViewDataSource, UITextViewDelegate, UITextFieldDelegate {
    
    @IBOutlet weak var tipoprodPicker: UIPickerView!
    @IBOutlet weak var precio: UITextField!
    @IBOutlet weak var fechaPicker: UIDatePicker!
    @IBOutlet weak var descripcion: UITextView!
    @IBOutlet weak var nombre: UITextField!
    @IBOutlet weak var mediaView: UIView!
    @IBOutlet weak var tipoTable: UITableView!
    @IBOutlet weak var zonaTable: UITableView!
     var dataSource = DataSource()
     var dataSourcet = DataSourcetipo()
    let tipo = [["Tipo de producto", "Alimentación", "Bebidas con alcohol", "Bebidas sin alcohol", "Congelados", " Lácteos", "Snacks"]]
    var itemst : [String] = ["Restaurante", "Cafeteria", "Hotel", "Gasolinera", "Alimentación tradicional", "Quiosco","Ocio nocturno", "Tenda de Snacks", "Restauración social"]
    var items : [String] = ["Noreste y Baleares", "Levante","Sur","Centro","Noroeste","Norte","Canarias"]
    var tipoSelected = ""
    let imagePicker = UIImagePickerController()
    var urlmedia = ""
    var idfab = ""
    private var indicador: UIActivityIndicatorView = UIActivityIndicatorView()
    var tipop:[String] = []
    
    override func viewDidLoad() {
        super.viewDidLoad()
        zonaTable.delegate = dataSource
        zonaTable.dataSource = dataSource
        tipoTable.delegate = dataSourcet
        tipoTable.dataSource = dataSourcet
        precio.delegate = self
        nombre.delegate = self
        fechaPicker.minimumDate=Date()
        self.getTipoProducto()
        tipoprodPicker.delegate = self
        tipoprodPicker.dataSource=self
        self.indicador.center=self.view.center
        self.indicador.autoresizingMask = [.flexibleBottomMargin, .flexibleLeftMargin, .flexibleWidth, .flexibleRightMargin, .flexibleTopMargin, .flexibleHeight, .flexibleBottomMargin]
        self.indicador.hidesWhenStopped = true
        self.indicador.style = .gray
        self.view.addSubview(self.indicador)
        // Uncomment the following line to preserve selection between presentations
        // self.clearsSelectionOnViewWillAppear = false

        // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
        // self.navigationItem.rightBarButtonItem = self.editButtonItem
    }
    
    override func viewWillAppear(_ animated: Bool) {
        self.getTipoProducto()
        tipoprodPicker.delegate = self
        tipoprodPicker.dataSource=self
        self.tableView.reloadData()
    }
    
    override func viewDidAppear(_ animated: Bool) {
        self.getTipoProducto()
        tipoprodPicker.delegate = self
        tipoprodPicker.dataSource=self
        self.tableView.reloadData()
    }
    
    override func viewDidLayoutSubviews() {
        super.viewDidLayoutSubviews()
    }
    
    func numberOfComponents(in pickerView: UIPickerView) -> Int {
        return 1
    }
    
    func pickerView(_ pickerView: UIPickerView, numberOfRowsInComponent component: Int) -> Int {
        
        if pickerView == tipoprodPicker
        {
            //return tipo[0].count
            return tipop.count + 1
        }
        
        return 0
    }
    
    func pickerView(_ pickerView: UIPickerView, titleForRow row: Int, forComponent component: Int) -> String? {
        if pickerView == tipoprodPicker
        {
            //return tipo[component][row]
            if(row == 0){
                return "Tipo de producto"
            }else{
                return tipop[row-1]
            }
            
        }
        
        return ""
    }
    
    func pickerView(_ pickerView: UIPickerView, didSelectRow row: Int, inComponent component: Int) {
        
        if pickerView == tipoprodPicker
        {
            //tipoSelected = tipo[0][row]
            if row == 0{
                tipoSelected = "Tipo de producto"
            }
            else{
                tipoSelected = tipop[row-1]
            }
            
        }
        
        
        // now, every time someone changes the Picker View's value, fruitSelected will be whatever they chose.
    }
    

    @IBAction func addMedia(_ sender: Any) {
        imagePicker.delegate=self
        imagePicker.sourceType = UIImagePickerController.SourceType.photoLibrary
        imagePicker.mediaTypes = UIImagePickerController.availableMediaTypes(for: UIImagePickerController.SourceType.photoLibrary)!
        self.present(imagePicker,animated: true,completion: nil)
        
    }
    
    
    @IBAction func addPromo(_ sender: Any) {
        UIApplication.shared.beginIgnoringInteractionEvents()
        indicador.startAnimating()
        let tipoesta = getAllTextFromTableView(tableView: self.tipoTable, array: itemst)
        let zona = getAllTextFromTableView(tableView: self.zonaTable, array: items)
        
        if (urlmedia == ""){
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "Se debe añadir una imagen o un video.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else if (nombre.text == ""){
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "Se debe añadir unnombre de promoción.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else if (descripcion.text == "" || descripcion.text == "Añadir descripción..."){
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "Se debe añadir una descripción de la promoción.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else if (precio.text == ""){
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "Se debe añadir un precio a la promoción.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else if tipoSelected.isEmpty || tipoSelected == "Tipo de producto"
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "Se debe seleccionar un tipo de producto.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else if tipoesta.count == 0
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "Se debe seleccionar al menos un tipo de establecimeinto.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else if zona.count == 0
        {
            UIApplication.shared.endIgnoringInteractionEvents()
            indicador.stopAnimating()
            let alert = UIAlertController(title: "Error", message: "Se debe seleccionar al menos una zona.", preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
            self.present(alert, animated: true, completion: nil)
        }
        else {
            var urlComponents = URLComponents()
            urlComponents.scheme = "http"
            urlComponents.host = "ec2-52-47-86-31.eu-west-3.compute.amazonaws.com"
            
            urlComponents.path = "/CreatePromo"
            let idFabricante = URLQueryItem(name: "idFabricante", value: idfab)
            let pname = URLQueryItem(name: "Nombre", value: nombre.text)
            let pdescripcion = URLQueryItem(name: "Descripcion", value: descripcion.text)
            let ppreciounitario = URLQueryItem(name: "PrecioUnitario", value: precio.text)
            let dateFormatter = DateFormatter()
            dateFormatter.dateFormat = "yyyy-MM-dd"
            let pfechacaducidad = URLQueryItem(name: "FechaCaducidad", value: dateFormatter.string(from: (fechaPicker?.date)!))
            let parchivoadjunto = URLQueryItem(name: "ArchivoAdjunto", value: "")
            let pimagen = URLQueryItem(name: "Imagen", value: urlmedia)
            let pzona = URLQueryItem(name: "Zona", value: "\(zona)" )
            let ptipoproducto = URLQueryItem(name: "TipoProducto", value: tipoSelected)
            let ptipoestablecimiento = URLQueryItem(name: "TipoEstablecimiento", value: "\(tipoesta)")
          
            urlComponents.queryItems = [idFabricante,pname,pdescripcion,ppreciounitario,pfechacaducidad,parchivoadjunto,pimagen,pzona,ptipoproducto,ptipoestablecimiento]
            guard let url = urlComponents.url else { fatalError("Could not create URL from components") }
            var request = URLRequest(url: url)
            request.httpMethod = "POST"
            let config = URLSessionConfiguration.default
            let session = URLSession(configuration: config)
            let task = session.dataTask(with: request) { (responseData, response, responseError) in
                DispatchQueue.main.async {
                    if let error = responseError {
                        print(error)
                        UIApplication.shared.endIgnoringInteractionEvents()
                        self.indicador.stopAnimating()
                        let alert = UIAlertController(title: "Error", message: "No se ha podido crear la promoción. Ha ocurrido un error en el sistema.", preferredStyle: UIAlertController.Style.alert)
                        alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                        alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                        self.present(alert, animated: true, completion: nil)
                    } else if let jsonData = responseData {
                        print(jsonData.description)
                        guard let peticionstatus = try? JSONDecoder().decode(PeticionStatus.self, from: jsonData) else {
                            UIApplication.shared.endIgnoringInteractionEvents()
                            self.indicador.stopAnimating()
                            let alert = UIAlertController(title: "Error", message: "Ha ocurrido un error en el sistema y no se ha podido guardar la promoción.", preferredStyle: UIAlertController.Style.alert)
                            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                            self.present(alert, animated: true, completion: nil)
                            return
                        }
                        if peticionstatus.status==200{
                            UIApplication.shared.endIgnoringInteractionEvents()
                            self.indicador.stopAnimating()
                            let alert = UIAlertController(title: "Promoción creada", message: "La promoción se ha creado con exito.", preferredStyle: UIAlertController.Style.alert)
                            let okAction = UIAlertAction(title: "OK", style: UIAlertAction.Style.default) {
                                UIAlertAction in
                                self.performSegue(withIdentifier: "backToLogin2", sender: nil)
                            }
                            alert.addAction(okAction)
                            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                            self.present(alert, animated: true, completion: nil)
                            
                        }
                        else{
                            UIApplication.shared.endIgnoringInteractionEvents()
                            self.indicador.stopAnimating()
                            let alert = UIAlertController(title: "Error", message: "Ha ocurrido un error en el sistema y no se ha podido guardar la promoción.", preferredStyle: UIAlertController.Style.alert)
                            alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                            alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                            self.present(alert, animated: true, completion: nil)
                            return
                            
                        }
                        
                        
                    }
                }
            }
            task.resume()
        }
    }
    
    func getAllTextFromTableView(tableView: UITableView, array: [String]) -> [String] {
        guard let indexPaths = tableView.indexPathsForSelectedRows else { // if no selected cells just return
        return []
        }
        var darray = [String]()
        for indexPath in indexPaths {
            print("\(array[indexPath.row])") //Here you get the text of cell
            darray.append(array[indexPath.row])
        }
        return darray
    }
    
    func imagePickerController(_ picker: UIImagePickerController, didFinishPickingMediaWithInfo info: [UIImagePickerController.InfoKey : Any]) {
        
        
        //getting details of image
        
        var imageURL = info[UIImagePickerController.InfoKey.mediaURL] as? URL
        if imageURL == nil{
            imageURL = info[UIImagePickerController.InfoKey.imageURL] as? URL
        }
        //let mediatype = info[UIImagePickerController.InfoKey.mediaType]
        
        var localFileName:String?
        if imageURL != nil
        {
            let imgName = imageURL?.lastPathComponent
            localFileName = imgName
        }
        
        if localFileName == nil
        {
            return
        }
        // Set photoImageView to display the selected image.
        //img.image = selectedImage
        
        // Configure AWS Cognito Credentials
        let myIdentityPoolId = "eu-west-2:a54ce1e4-5076-4996-8e69-ae65a5f9eba3"
        
        let credentialsProvider:AWSCognitoCredentialsProvider = AWSCognitoCredentialsProvider(regionType:AWSRegionType.EUWest2, identityPoolId: myIdentityPoolId)
        
        let configuration = AWSServiceConfiguration(region:AWSRegionType.EUWest2, credentialsProvider:credentialsProvider)
        
        AWSServiceManager.default().defaultServiceConfiguration = configuration
        
        // Set up AWS Transfer Manager Request
        let S3BucketName = "promohoreca1"
        let remoteName = localFileName!
        
        let uploadRequest = AWSS3TransferManagerUploadRequest()
        uploadRequest?.body = generateImageUrl(fileName: remoteName) as URL
        uploadRequest?.key = remoteName
        uploadRequest?.bucket = S3BucketName
        //uploadRequest?.contentType = "image/jpeg"
        
        let transferManager = AWSS3TransferManager.default()
        
        // Perform file upload
        transferManager.upload(uploadRequest!).continueWith(block: { (task:AWSTask) -> Any? in
            
            if let error = task.error {
                print("Upload failed with error: (\(error.localizedDescription))")

                let alert = UIAlertController(title: "Error", message: "No se ha podido cargar el archivo. (\(error.localizedDescription)).", preferredStyle: UIAlertController.Style.alert)
                alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                self.present(alert, animated: true, completion: nil)
            }
            
            if task.result != nil {
                let s3URL = URL(string: "https://s3.eu-west-2.amazonaws.com/\(S3BucketName)/\(uploadRequest!.key!)")!
                print("Uploaded to:\n\(s3URL)")
                self.urlmedia=s3URL.absoluteString
                // Read uploaded image and display in a view
                let imageData = NSData(contentsOf: s3URL as URL)
               
                
                if let downloadedImageData = imageData
                {
                    DispatchQueue.main.async {
                        if (localFileName?.lowercased().hasSuffix(".jpeg"))! || (localFileName?.lowercased().hasSuffix(".jpg"))! || (localFileName?.lowercased().hasSuffix(".png"))!{
                            let image = UIImage(data: downloadedImageData as Data)
                            for subview in self.mediaView.subviews {
                                subview.removeFromSuperview()
                            }
                            let vc = UIImageView()
                            vc.image = image
                            vc.contentMode = UIView.ContentMode.scaleAspectFit
                            vc.frame = self.mediaView.bounds
                            //self.addChild(vc)
                            self.mediaView.addSubview(vc)
                        }else if (localFileName?.lowercased().hasSuffix(".mov"))! || (localFileName?.lowercased().hasSuffix(".avi"))! || (localFileName?.lowercased().hasSuffix(".mp4"))!{
                            let player = AVPlayer(url: s3URL)
                            let vc = AVPlayerViewController()
                            vc.player = player
                            vc.view.frame = self.mediaView.bounds
                            vc.showsPlaybackControls=true
                            self.addChild(vc)
                            self.mediaView.addSubview(vc.view)
                            
                            
                            
                        }
                    }
                }
            }
            else {
                print("Unexpected empty result.")
                let alert = UIAlertController(title: "Error", message: "No se ha podido cargar el archivo.", preferredStyle: UIAlertController.Style.alert)
                alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                self.present(alert, animated: true, completion: nil)
            }
            return nil
        })
        
        // Dismiss the picker.
        dismiss(animated: true, completion: nil)
        
    }
    
    func generateImageUrl(fileName: String) -> NSURL
    {
        let fileURL = NSURL(fileURLWithPath: NSTemporaryDirectory().appendingFormat(fileName))
        
        return fileURL
    }
    
    func getTipoProducto(){
        var urlComponents = URLComponents()
        urlComponents.scheme = "http"
        urlComponents.host = "ec2-52-47-86-31.eu-west-3.compute.amazonaws.com"
        
        urlComponents.path = "/GetTipoProductos"
        let idFabricante = URLQueryItem(name: "idFabricante", value: idfab)
        
        
        urlComponents.queryItems = [idFabricante]
        guard let url = urlComponents.url else { fatalError("Could not create URL from components") }
        var request = URLRequest(url: url)
        request.httpMethod = "GET"
        let config = URLSessionConfiguration.default
        let session = URLSession(configuration: config)
        let task = session.dataTask(with: request) { (responseData, response, responseError) in
            DispatchQueue.main.async {
                if let error = responseError {
                    print(error)
                    UIApplication.shared.endIgnoringInteractionEvents()
                    self.indicador.stopAnimating()
                    let alert = UIAlertController(title: "Error", message: "No se ha podido obtener los tipo de productos.", preferredStyle: UIAlertController.Style.alert)
                    alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                    alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                    self.present(alert, animated: true, completion: nil)
                } else if let jsonData = responseData {
                    print(jsonData.description)
                    guard let tipo = try? JSONDecoder().decode(Tipoproducto.self, from: jsonData) else {
                        UIApplication.shared.endIgnoringInteractionEvents()
                        self.indicador.stopAnimating()
                        let alert = UIAlertController(title: "Error", message: "Ha ocurrido un error en el sistema y no se ha podido obtener los tipo de productos.", preferredStyle: UIAlertController.Style.alert)
                        alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                        alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                        self.present(alert, animated: true, completion: nil)
                        return
                    }
                    if tipo.tipoproducto.count > 0 {
                        self.reload(tipo: tipo)
                        
                    }
                    else{
                        UIApplication.shared.endIgnoringInteractionEvents()
                        self.indicador.stopAnimating()
                        let alert = UIAlertController(title: "Error", message: "Ha ocurrido un error en el sistema y no se ha podido obtener los tipo de productos.", preferredStyle: UIAlertController.Style.alert)
                        alert.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
                        alert.view.tintColor=UIColor(red: 22.0/255.0, green: 170.0/255.0, blue: 93.0/255.0, alpha: 1.0)
                        self.present(alert, animated: true, completion: nil)
                        return
                        
                    }
                    
                    
                }
            }
        }
        task.resume()
    }
    
    func reload(tipo:Tipoproducto){
        DispatchQueue.main.async{
            self.tipop = tipo.tipoproducto.components(separatedBy: ",")
            self.tableView.reloadData()
        }
    }
    
    
}
