//
//  imagepickerViewController.swift
//  PromoHoreca
//
//  Created by Mireia Izquierdo aymerich on 2/12/18.
//  Copyright © 2018 Mireia Izquierdo aymerich. All rights reserved.
//

import UIKit
import AWSCore
import AWSS3
import Photos
import AVFoundation
import AVKit

class imagepickerViewController: UIViewController,
    UIImagePickerControllerDelegate,
UINavigationControllerDelegate {

   
    @IBOutlet weak var mediaview: UIView!
    let imagePicker = UIImagePickerController()
    
    override func viewDidLoad() {
        super.viewDidLoad()

        // Do any additional setup after loading the view.
    }
    

    @IBAction func imageSelected(_ sender: Any) {
        imagePicker.delegate=self
        imagePicker.sourceType = UIImagePickerController.SourceType.photoLibrary
        imagePicker.mediaTypes = UIImagePickerController.availableMediaTypes(for: UIImagePickerController.SourceType.photoLibrary)!
        self.present(imagePicker,animated: true,completion: nil)
    }
    
    func imagePickerController(_ picker: UIImagePickerController, didFinishPickingMediaWithInfo info: [UIImagePickerController.InfoKey : Any]) {
        

        //getting details of image
        
        var imageURL = info[UIImagePickerController.InfoKey.mediaURL] as? URL
        if imageURL == nil{
            imageURL = info[UIImagePickerController.InfoKey.imageURL] as? URL
        }
        //let mediatype = info[UIImagePickerController.InfoKey.mediaType]
        
        var localFileName:String?
        if imageURL != nil
        {
            let imgName = imageURL?.lastPathComponent
            localFileName = imgName
        }
        
        if localFileName == nil
        {
            return
        }
        // Set photoImageView to display the selected image.
        //img.image = selectedImage
        
        // Configure AWS Cognito Credentials
        let myIdentityPoolId = "eu-west-2:a54ce1e4-5076-4996-8e69-ae65a5f9eba3"
        
        let credentialsProvider:AWSCognitoCredentialsProvider = AWSCognitoCredentialsProvider(regionType:AWSRegionType.EUWest2, identityPoolId: myIdentityPoolId)
        
        let configuration = AWSServiceConfiguration(region:AWSRegionType.EUWest2, credentialsProvider:credentialsProvider)
        
        AWSServiceManager.default().defaultServiceConfiguration = configuration
        
        // Set up AWS Transfer Manager Request
        let S3BucketName = "promohoreca1"
        let remoteName = localFileName!
        
        let uploadRequest = AWSS3TransferManagerUploadRequest()
        uploadRequest?.body = generateImageUrl(fileName: remoteName) as URL
        uploadRequest?.key = remoteName
        uploadRequest?.bucket = S3BucketName
        //uploadRequest?.contentType = "image/jpeg"
        
        let transferManager = AWSS3TransferManager.default()
        
        // Perform file upload
        transferManager.upload(uploadRequest!).continueWith(block: { (task:AWSTask) -> Any? in
            
            if let error = task.error {
                print("Upload failed with error: (\(error.localizedDescription))")
            }
            
            if task.result != nil {
                let s3URL = URL(string: "https://s3.eu-west-2.amazonaws.com/\(S3BucketName)/\(uploadRequest!.key!)")!
                print("Uploaded to:\n\(s3URL)")
                
                // Read uploaded image and display in a view
                let imageData = NSData(contentsOf: s3URL as URL)
                
                if let downloadedImageData = imageData
                {
                    DispatchQueue.main.async {
                        if (localFileName?.lowercased().hasSuffix(".jpeg"))! || (localFileName?.lowercased().hasSuffix(".jpg"))! || (localFileName?.lowercased().hasSuffix(".png"))!{
                            let image = UIImage(data: downloadedImageData as Data)
                            let vc = UIImageView()
                            vc.image = image
                            vc.contentMode = UIView.ContentMode.scaleAspectFit
                            vc.frame = self.mediaview.bounds
                            //self.addChild(vc)
                            self.mediaview.addSubview(vc)
                        }else if (localFileName?.lowercased().hasSuffix(".mov"))! || (localFileName?.lowercased().hasSuffix(".avi"))! || (localFileName?.lowercased().hasSuffix(".mp4"))!{
                            let player = AVPlayer(url: s3URL)
                            let vc = AVPlayerViewController()
                            vc.player = player
                            vc.view.frame = self.mediaview.bounds
                            vc.showsPlaybackControls=true
                            self.addChild(vc)
                            self.mediaview.addSubview(vc.view)
                            
                            
                        }
                    }
                }
            }
            else {
                print("Unexpected empty result.")
            }
            return nil
        })
        
        // Dismiss the picker.
        dismiss(animated: true, completion: nil)
    }

    func generateImageUrl(fileName: String) -> NSURL
    {
        let fileURL = NSURL(fileURLWithPath: NSTemporaryDirectory().appendingFormat(fileName))
        
        return fileURL
    }
    
}
